﻿//*****************************************************************************
//* Copyright (c) 2011-2013 Miday Workshop All rights reserved.
//*
//* File: CalcSDK.cpp
//*****************************************************************************

/* -*- Mode: C++; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*************************************************************************
 *
 *  The Contents of this file are made available subject to the terms of
 *  the BSD license.
 *  
 *  Copyright 2000, 2010 Oracle and/or its affiliates.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *  1. Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *  2. Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 *  3. Neither the name of Sun Microsystems, Inc. nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 *  OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 *  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
 *  TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 *  USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *     
 *************************************************************************/

//==========================　定義　あると表示
//#define _TEST_VIEW
//==========================
//==========================　定義　テスト出力
//#define _TEST_WRITE
//==========================

#ifdef _SDK
#ifdef _WINDOWS_PLAT
#include <winsock2.h>
#else  //_WINDOWS_PLAT
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdint.h>
#endif  //_WINDOWS_PLAT

#include <new>
#include <stdio.h>
#include <wchar.h>
#include <string.h>

#include <sal/main.h>

#include <cppuhelper/bootstrap.hxx>

#include <osl/file.hxx>
#include <osl/process.h>
#include <rtl/process.h>

#include <com/sun/star/awt/FontSlant.hpp>
#include <com/sun/star/beans/XPropertySet.hpp>
#include <com/sun/star/bridge/XUnoUrlResolver.hpp>
#include <com/sun/star/frame/XComponentLoader.hpp>
#include <com/sun/star/frame/XDesktop.hpp>
#include <com/sun/star/frame/XDispatchHelper.hpp>
#include <com/sun/star/lang/XMultiComponentFactory.hpp>
#include <com/sun/star/lang/XMultiServiceFactory.hpp>
#include <com/sun/star/registry/XSimpleRegistry.hpp>
#include <com/sun/star/sheet/XCellRangeAddressable.hpp>
#include <com/sun/star/sheet/XSpreadsheet.hpp>
#include <com/sun/star/sheet/XSpreadsheetDocument.hpp>
#include <com/sun/star/sheet/XSpreadsheetView.hpp>
#include <com/sun/star/table/CellHoriJustify.hpp>
#include <com/sun/star/table/CellVertJustify.hpp>
#include <com/sun/star/table/TableBorder.hpp>
#include <com/sun/star/table/XCellRange.hpp>
#include <com/sun/star/table/XColumnRowRange.hpp>
#include <com/sun/star/text/XText.hpp>
#include <com/sun/star/util/XCloseable.hpp>
#include <com/sun/star/util/XMergeable.hpp>
#include <com/sun/star/view/XMultiSelectionSupplier.hpp>
#include <com/sun/star/view/XViewCursor.hpp>

#include "CalcDef.h"
#include "MsgLocale.h"

using namespace rtl;
using namespace com::sun::star::awt;
using namespace com::sun::star::beans;
using namespace com::sun::star::bridge;
using namespace com::sun::star::container;
using namespace com::sun::star::frame;
using namespace com::sun::star::lang;
using namespace com::sun::star::registry;
using namespace com::sun::star::sheet;
using namespace com::sun::star::table;
using namespace com::sun::star::text;
using namespace com::sun::star::uno;
using namespace com::sun::star::util;
using namespace com::sun::star::view;
using namespace cppu;

//using ::rtl::OUString;
//using ::rtl::OUStringToOString;

#define SERVICE "uno:socket,host=localhost,port=2083;urp;StarOffice.ServiceManager"

#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
#define SERVER_PARM L"soffice.exe\" -headless -nofirststartwizard -accept=socket,host=localhost,port=2083;urp;StarOffice.ServiceManager"
#else  //_UNICODE_TABLE
#define SERVER_PARM "soffice.exe\" -headless -nofirststartwizard -accept=socket,host=localhost,port=2083;urp;StarOffice.ServiceManager"
#endif  //_UNICODE_TABLE
//#define SERVER_PARM "soffice.exe\" -accept=socket,host=localhost,port=2083;urp;StarOffice.ServiceManager"
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
#define SERVER_PARM L"soffice.bin --headless --nofirststartwizard --accept='socket,host=localhost,port=2083;urp;StarOffice.ServiceManager'"
#else  //_UNICODE_TABLE
#define SERVER_PARM "soffice.bin --headless --nofirststartwizard --accept='socket,host=localhost,port=2083;urp;StarOffice.ServiceManager'"
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT

static Reference<XComponent> ClDoc;

//==============================================================================
//Calcの終了処理
//==============================================================================
int CalcEnd() {
//------------------------------------------------------------------------------
//シートクローズ
//------------------------------------------------------------------------------
	try {
#ifndef _TEST_VIEW
		Reference<XCloseable> xCloseable(ClDoc, UNO_QUERY);
		if( xCloseable.is() ) {
			xCloseable->close(false);
			ClDoc = NULL;
		}
#endif
	}
	catch ( ::cppu::BootstrapException & e ) {
		//	"caught BootstrapException: "
		//	OUStringToOString( e.getMessage(), RTL_TEXTENCODING_ASCII_US ).getStr()
		FreeArea();
		return SDK_ERROR;
	}
	catch ( Exception & e ) {
		//	"caught UNO exception: "
		//	OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US ).getStr()
		FreeArea();
		return SDK_ERROR;
	}

#ifdef _WINDOWS_PLAT
	WSACleanup();
#endif  //_WINDOWS_PLAT
#ifdef _LINUX_PLAT
	Window_Refresh();
#endif  //_LINUX_PLAT
	return NOMAL_RETURN;
}

//==============================================================================
//Calcを起動し、セルの情報を取り込む
//==============================================================================
//SAL_IMPLEMENT_MAIN_WITH_ARGS(argc, argv) {
int CalcAcc() {
	Any any_work1;
	int ih, iw;

	BorderLine theLine;
	TableBorder bord;
	int ia, ix, iw2, ih2, irc;
	int mrg_wk[4];
	int sabun;
	int col, row;
	UNICHAR *str;

	sal_Int32 cellColor;
	float hyo_size;          //sal_Int32
	float hyo_bold;          //sal_Int32
	float hyo_underline;     //sal_Int32
	float hyo_strikethrough; //sal_Int32
//	float hyo_italic;
//	sal_Int16 hyo_italic;
	::com::sun::star::table::CellHoriJustify hyo_hori;//横位置　この型でないと取り出せない
	::com::sun::star::awt::FontSlant         hyo_italic;//斜体　この型でないと取り出せない
	sal_Int32 hyo_bcolor;

#if !defined(_MSC_VER) || _MSC_VER < 1400
	size_t sizew, sizew2;
#else  //MSC
	size_t sizew, sizew2;
#endif  //MSC

	Proc_pos = 0;

#ifdef _LINUX_PLAT
	Window_Refresh();
#endif //_LINUX_PLAT
	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	col = 0;
	row = 0;

	//クリップボードを調べデータ分の枠を作る
#ifdef _WINDOWS_PLAT
	//Windows版SDKの処理 Linux版はGtkMainで行う
	text_flag = ClipCheck();
	if ( text_flag == IN_NOTDATA ) {
		return FINISHING_MESSAGE;
	}

	if ( text_flag == IN_TEXTDATA || text_flag == IN_UNIDATA ) {
		if ( MessageDisp( MSG_ALL_LINE_CODE ) != IDOK ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			return CANCEL_RETURN;
		}

		if ( ClipRead( &clip_data ) != NOMAL_RETURN ) {
			FreeArea();
			return FINISHING_MESSAGE;
		}
		Clip_alloc = 1;
	}
#endif  //_WINDOWS_PLAT

	if ( text_flag == IN_TEXTDATA || text_flag == IN_UNIDATA ) {
		//クリップボードのデータを分割する
		if ( DataDivision(clip_data) != 0 ) {//メモリ確保エラー
			FreeArea();
			return MEMORY_ERROR;
		}

		ProgressView(90);
		return NOMAL_RETURN;//エリアは開放しない
	}

//------------------------------------------------------------------------------
//接続
//------------------------------------------------------------------------------
	Proc_pos = 1;
#ifdef _WINDOWS_PLAT
	WSADATA wsaData;
	if ( WSAStartup(MAKEWORD(2,2), &wsaData) ) {
		return SDK_ERROR;
	}
#endif  //_WINDOWS_PLAT
	try {
		OUString sConnectionString(RTL_CONSTASCII_USTRINGPARAM(SERVICE));

		Reference<XComponentContext> xComponentContext;
		if ( Verno == 0 ) {//3.3以下の場合
/*4.1では、このブロックはコンパイルエラー
			//レジストリサービスのインスタンスを作成
			Reference<XSimpleRegistry> xSimpleRegistry(::cppu::createSimpleRegistry() );

			//レジストリを接続
			xSimpleRegistry->open( OUString( RTL_CONSTASCII_USTRINGPARAM(LIT_RDB_FILEA) ), sal_True, sal_False );

			//Win版3.3では通った
			xComponentContext = ::cppu::bootstrap_InitialComponentContext( xSimpleRegistry );
*/
		} else if ( Verno >= 1 ) {//3.4以上の場合
			xComponentContext= ::cppu::defaultBootstrap_InitialComponentContext();
		}

		//サーバーマネージャのインスタンスを取り出す
		Reference<XMultiComponentFactory> xMultiComponentFactoryClient(
			xComponentContext->getServiceManager() );

		//コンポーネントのインスタンスを作成
		Reference<XInterface> xInterface =
			xMultiComponentFactoryClient->createInstanceWithContext( 
				OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.bridge.UnoUrlResolver")),
				xComponentContext );

		Reference<XUnoUrlResolver> resolver( xInterface, UNO_QUERY );

//------------------------------------------------------------------------------
//サーバー起動
//------------------------------------------------------------------------------
		for(ia=0; ia<RUN_COUMT; ia++) {
			//Officeのコンポーネントの状況を確認
			try {
				xInterface = Reference<XInterface> ( resolver->resolve( sConnectionString ), UNO_QUERY );
			}
			catch ( Exception& e ) {
				if ( ia == 0 ) {
					ServerRun((UNICHAR *)SERVER_PARM);
				}
				if ( ia < RUN_COUMT-1 ) {
#ifdef _WINDOWS_PLAT
					Sleep(100);
#else  //_WINDOWS_PLAT
					sleep(1);
#endif  //_WINDOWS_PLAT
					continue;
				} else {
					MessageDisp(MSG_ER_SER_CODE);//起動できなかった
					return FINISHING_MESSAGE;
				}
			}
			break;
		}

//------------------------------------------------------------------------------
//サービスマネージャを取り出す
//------------------------------------------------------------------------------
		Proc_pos = 3;
		//Office component factoryからserver component contextのプロパティを取り出す
		Reference<XPropertySet> xPropSet( xInterface, UNO_QUERY );
		xPropSet->getPropertyValue( OUString( RTL_CONSTASCII_USTRINGPARAM("DefaultContext")) ) >>= xComponentContext;

		//Officeのサービスマネージャを取り出す
		Reference<XMultiComponentFactory> xMultiComponentFactoryServer(
			xComponentContext->getServiceManager() );
		ProgressView(10);

//------------------------------------------------------------------------------
//デスクトップを取り出す
//------------------------------------------------------------------------------
		Reference<XComponentLoader> ClStardesktop(
			xMultiComponentFactoryServer->createInstanceWithContext( 
				OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.frame.Desktop") ),
				xComponentContext ), UNO_QUERY );
		if (!ClStardesktop.is()) {
			//現在のコンポーネントが取り出せなかった
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}

/*		Reference<XDesktop> xdesktop(ClStardesktop, UNO_QUERY);
		if (!xdesktop.is()) {
			//XDesktopの照会ができなかった
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}*/

//------------------------------------------------------------------------------
//assocを取り出す
//------------------------------------------------------------------------------
		Reference<XComponentLoader> ClDispValue(
			xMultiComponentFactoryServer->createInstanceWithContext( 
				OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.beans.PropertyValue") ),
				xComponentContext ), UNO_QUERY );

//------------------------------------------------------------------------------
//非表示にする
//------------------------------------------------------------------------------
		Sequence<PropertyValue> loadprops(1); 
		loadprops[0].Name =    OUString( RTL_CONSTASCII_USTRINGPARAM("Hidden"));
#if defined(_TEST_VIEW) || defined(_TROUBLE_EVASION)
		if ( MTRCMP(Evasion, INI_ON) == 0 ) {
			loadprops[0].Value <<= sal_False;
		} else {
			loadprops[0].Value <<= sal_True;
		}
#else
		loadprops[0].Value <<= sal_True;
#endif  //_TEST_VIEW

//------------------------------------------------------------------------------
//新しい文書を開く
//------------------------------------------------------------------------------
		//Calcの文書を新規に開く
		ClDoc = ClStardesktop->loadComponentFromURL(
		    OUString( RTL_CONSTASCII_USTRINGPARAM("private:factory/scalc")),
		    OUString( RTL_CONSTASCII_USTRINGPARAM("_blank")), 0,  //0=AUTO
//#ifndef _TEST_VIEW
			loadprops);
//#else  //_TEST_VIEW
//			Sequence<::com::sun::star::beans::PropertyValue> () );
//#endif  //_TEST_VIEW
		if ( !ClDoc.is() ) {
			//文書を開けなかった
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}

		Reference<XSpreadsheetDocument> ClSheets (ClDoc, UNO_QUERY);
		Reference<XSpreadsheets> rSheets = ClSheets->getSheets();

		//XSpreadsheetインターフェースの質問
		Reference<XModel> rSpreadsheetModel (ClSheets, UNO_QUERY);
		//モデルから現在のコントローラーを取り出す
		Reference<XController> ClController =rSpreadsheetModel->getCurrentController();

		Reference<XSpreadsheetView> rSpreadsheetView (ClController, UNO_QUERY);
		Reference<XSpreadsheet> ClActiveSheet = rSpreadsheetView->getActiveSheet( );
		Reference<XSpreadsheet> rSpSheet (ClActiveSheet, UNO_QUERY);


		Reference<XMultiServiceFactory> rOfficeServiceManager(xInterface, UNO_QUERY);


		//初期化したコンポーネントコンテキストを作成
		Reference<XComponentContext> rComponentContext = defaultBootstrap_InitialComponentContext();

		//コンテキストからサービスマネージャを探す
		Reference<XMultiComponentFactory> rServiceManager = rComponentContext->getServiceManager();

		//サービスマネージャでインスタンスを作成する
		Reference<XInterface> rInstance =  rServiceManager->createInstanceWithContext(
		    OUString( RTL_CONSTASCII_USTRINGPARAM("com.sun.star.bridge.UnoUrlResolver")), rComponentContext );

		//XUnoUrlResolverインターフェースの問い合わせ
		Reference<XUnoUrlResolver> rResolver( rInstance, UNO_QUERY );
		if( ! rResolver.is() ) {
//			printf("Error: Couldn't instantiate com.sun.star.bridge.UnoUrlResolver service\n");
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}


		Reference<XDispatchHelper> ClHelper = Reference<XDispatchHelper>
		    ( rOfficeServiceManager->createInstance(
		    OUString( RTL_CONSTASCII_USTRINGPARAM(
		    "com.sun.star.frame.DispatchHelper"))), UNO_QUERY );

		if( ! ClHelper.is() ) {
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}


		Reference<XFrame> ClFrame = ClController->getFrame();
		Reference<XDispatchProvider> rDispatchProvider(ClFrame, UNO_QUERY);

		if( ! ClFrame.is() ) {
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}
		if( ! rDispatchProvider.is() ) {
			irc = CalcEnd();
			FreeArea();
			return SDK_ERROR;
		}

//------------------------------------------------------------------------------
//A1のセルに移動
//------------------------------------------------------------------------------
		Sequence<PropertyValue> args1(1);
		args1[0].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("ToPoint"));
		args1[0].Value <<= OUString( RTL_CONSTASCII_USTRINGPARAM("$A$1"));

		ClHelper->executeDispatch(rDispatchProvider,
		    OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:GoToCell")),
		    OUString( RTL_CONSTASCII_USTRINGPARAM("")),
		    0, args1);

//------------------------------------------------------------------------------
//クリップボードからペースト
//------------------------------------------------------------------------------
		Proc_pos = 4;
//printf("ペースト開始\n");
		Sequence<PropertyValue> args2(6);
		args2[0].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("Flags"));
		args2[0].Value <<= OUString( RTL_CONSTASCII_USTRINGPARAM("A"));//A SVDNT

		args2[1].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("FormulaCommand"));//演算
		args2[1].Value = makeAny((sal_Int32)0);
		args2[2].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("SkipEmptyCells"));//空白のスキップ
		args2[2].Value <<= false;
		args2[3].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("Trancepose"));//行列の入れ替え
		args2[3].Value <<= false;
		args2[4].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("Aslink"));//リンク
		args2[4].Value <<= false;
		args2[5].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("MovrMode"));//移動
		args2[5].Value = makeAny((sal_Int32)4);

		ClHelper->executeDispatch(rDispatchProvider,
		    OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:Paste")),//ペーストのみにする　テキスト廃止のため
//		    OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:InsertContents")),
		    OUString( RTL_CONSTASCII_USTRINGPARAM("")),
		    0, args2);
//printf("ペースト終了\n");

//------------------------------------------------------------------------------
//選択範囲を調べる
//------------------------------------------------------------------------------
		Proc_pos = 5;
		Col_no   = 0;
		Row_no   = 0;

		Reference<XInterface> ClArea = rSpreadsheetModel->getCurrentSelection();

		Reference<XColumnRowRange> rSheetColRange (ClArea, UNO_QUERY);
		Reference<XTableColumns> rSheetColumns;

		//貼り付けに失敗した(Calcのデータではないと思われる)
		if ( rSheetColRange == NULL ) {
#ifdef _WINDOWS_PLAT
			if ( MessageDisp( MSG_ER_APP_CODE ) != IDOK ) {
#else  //_WINDOWS_PLAT
			if ( MessageDisp( MSG_ALL_LINE_CODE ) != GTK_RESPONSE_OK ) {
#endif  //_WINDOWS_PLAT
				irc = MessageDisp( MSG_CANCLE_CODE );
				irc = CalcEnd();
				FreeArea();
				return CANCEL_RETURN;
			} else {
				//クリップボードから直接読み込む
				Allline_flag = 1;
#ifdef _WINDOWS_PLAT
				if ( ClipRead( &clip_data ) != NOMAL_RETURN ) {
					irc = CalcEnd();
					FreeArea();
					return FINISHING_MESSAGE;
				}
				Clip_alloc = 1;
#endif  //_WINDOWS_PLAT
				//Linuxではテキストデータは既に入力済み

				//クリップボードのデータを分割する
				if ( DataDivision(clip_data) != 0 ) {//メモリ確保エラー
					irc = CalcEnd();
					FreeArea();
					return MEMORY_ERROR;
				}

				ProgressView(90);
				return NOMAL_RETURN;//エリアは開放しない
			}
		}

		rSheetColumns = rSheetColRange->getColumns();//テキストで非表示だと、ここでエラーになる
		Col_no = rSheetColumns->getCount();
		Reference<XColumnRowRange> rSheetRowRange (ClArea, UNO_QUERY);
		Reference<XTableRows> rSheetRows = rSheetRowRange->getRows();
		Row_no = rSheetRows->getCount();
//printf("col= %d row= %d\n", Col_no, Row_no);

		if ( Col_no == 0 || Row_no == 0 ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			irc = CalcEnd();
			FreeArea();
			Break_flag = 2;
			return CANCEL_RETURN;
		}
		ProgressView(20);

//------------------------------------------------------------------------------
//領域確保
//------------------------------------------------------------------------------
#ifdef _LINUX_PLAT
		Window_Refresh();
#endif  //_LINUX_PLAT
		if ( Break_flag == 1 ) {
			irc = MessageDisp( MSG_CANCLE_CODE );
			irc = CalcEnd();
			FreeArea();
			Break_flag = 2;
			return CANCEL_RETURN;
		}

		//領域確保
		if ( AllocArea() != 0 ) {
			irc = CalcEnd();
			FreeArea();
			return MEMORY_ERROR;
		}
		sabun = 60 * 1000 / Row_no;	//60%を分割
		ProgressView(30);

//------------------------------------------------------------------------------
//セル位置指定
//------------------------------------------------------------------------------
		for(ih=0; ih<Row_no; ih++) {
			for(iw=0; iw<Col_no; iw++) {
				Reference<XCell> ClCell = rSpSheet->getCellByPosition(iw, ih);

//------------------------------------------------------------------------------
//文字列取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				ClCell->setFormula(OUString( RTL_CONSTASCII_USTRINGPARAM("ABCDEF")));//OK
#endif  //_TEST_WRITE

				sizew = ClCell->getFormula().getLength();

				try{
					str = new UNICHAR[sizew+1];
				}
				catch (...) {
					irc = CalcEnd();
					FreeArea();
					return MEMORY_ERROR;
				}
				if ( CharLenNewAlloc(&hyo[ih*Col_no+iw].text, sizew) == MEMORY_ERROR ) {
					irc = CalcEnd();
					FreeArea();
					return MEMORY_ERROR;
				}
#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
				MTRCPY( str, sizew+1, ClCell->getFormula().getStr());
#else  //_UNICODE_TABLE
#if !defined(_MSC_VER) || _MSC_VER < 1400
				sizew2 = wcstombs( str, OUStringToOString (ClCell->getFormula(), RTL_TEXTENCODING_UTF8).getStr(), sizew + 1);
#else  //MSC
				wcstombs_s( &sizew2, str, sizew+1, ClCell->getFormula().getStr(), sizew);//-1が返ってきた場合
#endif  //MSC
				if ( sizew2 == -1 ) {
					irc = MessageDisp( MSG_ER_CHAR_CODE );
					irc = CalcEnd();
					FreeArea();
					delete str;
					return FINISHING_MESSAGE;
				}
				str[sizew] = LIT_NULL_C;
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
				sizew2 = mbstowcs( str, OUStringToOString (ClCell->getFormula(), RTL_TEXTENCODING_UTF8).getStr(), sizew);//-1が返ってきた場合
				if ( sizew2 == -1 ) {
					irc = MessageDisp( MSG_ER_CHAR_CODE );
					irc = CalcEnd();
					FreeArea();
					delete str;
					return FINISHING_MESSAGE;
				}
				str[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
				MTRCPY( str, sizew+1, (const char *)ClCell->getFormula().getStr());
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT
				MTRCPY( hyo[ih*Col_no+iw].text.data, hyo[ih*Col_no+iw].text.size+1, str);
				delete str;

//------------------------------------------------------------------------------
//文字位置取り込み
//------------------------------------------------------------------------------
//				switch (ClCell->getType()){
//					case CellContentType_EMPTY : printf("Type = Empty\n");break;
//					case CellContentType_VALUE : printf("Type = Numerical Value\n");break;
//					case CellContentType_TEXT : printf("Type = Text\n");break;
//					case CellContentType_FORMULA : printf("Type = Formula\n");break;
//				}

				Reference<XPropertySet> rCellProps (ClCell, UNO_QUERY); 
#ifdef _TEST_WRITE
				any_work1 <<= makeAny((long)2);
				rCellProps->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("HoriJustify")), any_work1);
				rCellProps->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("VertJustify")), any_work1);
#endif  //_TEST_WRITE

				any_work1 = rCellProps->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("HoriJustify")));
				any_work1 >>= hyo[ih*Col_no+iw].h_ichi;
//				printf("文字横位置　%x %x \n", (unsigned int)hyo[ih*Col_no+iw].h_ichi, (unsigned int)CellHoriJustify_RIGHT);
				any_work1  >>= hyo_hori;
				hyo[ih*Col_no+iw].h_ichi = hyo_hori;

				any_work1 = rCellProps->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("VertJustify")));
				any_work1 >>= hyo[ih*Col_no+iw].v_ichi;
//				printf("文字縦位置　%x \n", (unsigned int)hyo[ih*Col_no+iw].v_ichi);

#if defined(_WIKI) || defined(_HTML)
//------------------------------------------------------------------------------
//セルの文字色の属性取り込み
//------------------------------------------------------------------------------
				Reference<XText> xText = Reference<XText>(ClCell, UNO_QUERY);
				Reference<XTextCursor> xTextCursor = xText->createTextCursor();
				xTextCursor = xText->createTextCursor();
				Reference<XPropertySet> oCPS(xTextCursor, UNO_QUERY);
#ifdef _TEST_WRITE
				any_work1 <<= (long)0xFF0000; // color red
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharColor")), any_work1);
#endif  //_TEST_WRITE

				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharColor")));
				any_work1 >>= cellColor;
				hyo[ih*Col_no+iw].fcolor = cellColor;
				if ( hyo[ih*Col_no+iw].fcolor == 0xffffffff ) {//0xffffffff=-1=デフォルト
					hyo[ih*Col_no+iw].fcolor = (unsigned int)0x00000000;//自動なら黒
				}
//				printf("文字色 %8.8x \n", hyo[ih*Col_no+iw].fcolor);

//------------------------------------------------------------------------------
//セルの文字の大きさ取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				any_work1 <<= (long)0x000008;
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharHeight")), any_work1);
#endif  //_TEST_WRITE

				hyo_size = 0;
				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharHeight")));
				any_work1 >>= hyo_size;
				hyo[ih*Col_no+iw].size = hyo_size;
//				printf("文字高さ %d \n", hyo[ih*Col_no+iw].size);

//------------------------------------------------------------------------------
//セルの太字属性取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				any_work1 <<= 150.0;
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharWeight")), any_work1);
#endif  //_TEST_WRITE

				hyo_bold = 0;
				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharWeight")));
				any_work1 >>= hyo_bold;
				if ( hyo_bold >= FONT_WEIGHT_BOLD ) {
					hyo[ih*Col_no+iw].bold = true;
				} else {
					hyo[ih*Col_no+iw].bold = false;
				}
//				printf("文字太さ %d \n", hyo[ih*Col_no+iw].bold);

//------------------------------------------------------------------------------
//セルの下線取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				any_work1 <<= (short)0x0001;
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharUnderline")), any_work1);
#endif  //_TEST_WRITE

				hyo_underline = 0;
				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharUnderline")));
				any_work1 >>= hyo_underline;
				hyo[ih*Col_no+iw].underline = hyo_underline;
//				printf("下線 %d \n", hyo[ih*Col_no+iw].underline);

//------------------------------------------------------------------------------
//セルの取り消し線取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				any_work1 <<= (long)0x000002;
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharStrikeout")), any_work1);
#endif  //_TEST_WRITE

				hyo_strikethrough = 0;
				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharStrikeout")));
				any_work1 >>= hyo_strikethrough;
				hyo[ih*Col_no+iw].strikethrough = hyo_strikethrough;
//				printf("取消し %d \n", hyo[ih*Col_no+iw].strikethrough);

//------------------------------------------------------------------------------
//セルの斜体属性取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				any_work1 <<= (long)0x000002;
				oCPS->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharPosture")), any_work1);
#endif  //_TEST_WRITE

//				hyo_italic = 0;
				any_work1 = oCPS->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CharPosture")));
				any_work1 >>= hyo_italic;
				if ( hyo_italic == FONT_SLANT_ITALIC ) {//斜体なら
					hyo[ih*Col_no+iw].italic = true;
				} else {
					hyo[ih*Col_no+iw].italic = false;
				}
//				printf("斜体=2 %d \n", hyo[ih*Col_no+iw].italic);
//printf("文字列　%ls\n", ClCell->getFormula().getStr());//getValue()は何?   unicodeで出力

//------------------------------------------------------------------------------
//セルの背景色の属性取り込み
//------------------------------------------------------------------------------
				Reference<XPropertySet> xPropertySet (ClCell, UNO_QUERY);

#ifdef _TEST_WRITE
				any_work1 <<= (long)0x00ff00;
				xPropertySet->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CellBackColor")), any_work1);
#endif  //_TEST_WRITE

				hyo_bcolor = 0;
				any_work1 = xPropertySet->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("CellBackColor")));
				any_work1 >>= hyo_bcolor;
				hyo[ih*Col_no+iw].bcolor = hyo_bcolor;
				if ( hyo[ih*Col_no+iw].bcolor == 0xffffffff ) {//0xffffffff=-1=デフォルト
					hyo[ih*Col_no+iw].bcolor = (unsigned int)0x00ffffff;//自動なら白
				}
//				printf("背景色 %8.8x \n", hyo[ih*Col_no+iw].bcolor);
#endif  //_WIKI _HTML

//------------------------------------------------------------------------------
//セルの線のインスタンス取り込み
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//セルの線の色取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
#if defined(_WIKI) || defined(_HTML)
				theLine.Color = 0xff0000;
#endif  //_WIKI _HTML
				theLine.InnerLineWidth = 19;
				theLine.OuterLineWidth = 19;
	// apply line description to all border lines and make them valid
//	TableBorder bord = new TableBorder();
				bord.VerticalLine = bord.HorizontalLine =
					bord.LeftLine = bord.RightLine =
					bord.TopLine = bord.BottomLine =
						theLine;
				bord.IsVerticalLineValid = bord.IsHorizontalLineValid =
					bord.IsLeftLineValid = bord.IsRightLineValid =
					bord.IsTopLineValid = bord.IsBottomLineValid =
						true;

				any_work1 <<= bord;
				rCellProps->setPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("TableBorder")), any_work1);
#endif  //_TEST_WRITE

				any_work1 = rCellProps->getPropertyValue(OUString( RTL_CONSTASCII_USTRINGPARAM("TableBorder")));
				any_work1 >>= bord;
				for( ix=0; ix<4; ix++ ) {
					switch( ix ) {
					case 0: theLine = bord.LeftLine;   break;
					case 1: theLine = bord.RightLine;  break;
					case 2: theLine = bord.TopLine;    break;
					case 3: theLine = bord.BottomLine; break;
					}
#if defined(_WIKI) || defined(_HTML)
					hyo[ih*Col_no+iw].lcolor[ix] = theLine.Color;
#endif  //_WIKI _HTML
					if ((theLine.InnerLineWidth > 80) || (theLine.OuterLineWidth > 80) || ((theLine.InnerLineWidth > 0) && (theLine.OuterLineWidth > 0) )) {
						hyo[ih*Col_no+iw].line[ix] = 2;
					} else if ((theLine.InnerLineWidth> 0) || (theLine.OuterLineWidth > 0) ) {
						hyo[ih*Col_no+iw].line[ix] = 1;
					} else {
						hyo[ih*Col_no+iw].line[ix] = 0;
					}
//					printf("線色 %8.8x 太さ %d \n", hyo[ih*Col_no+iw].lcolor[0], hyo[ih*Col_no+iw].line[0] );
				}

//------------------------------------------------------------------------------
//マージ範囲取り込み
//------------------------------------------------------------------------------
#ifdef _TEST_WRITE
				Sequence<PropertyValue> args3(1);
				args3[0].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("ToPoint"));
				args3[0].Value <<= OUString( RTL_CONSTASCII_USTRINGPARAM("$A$5:$B$5"));
				ClHelper->executeDispatch(rDispatchProvider,
				    OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:GoToCell")),
				    OUString( RTL_CONSTASCII_USTRINGPARAM("")),
				    0, args3);

				Sequence<PropertyValue> args4(1);
				args4[0].Name = OUString( RTL_CONSTASCII_USTRINGPARAM("MoveContents"));
				args4[0].Value <<= true;
				ClHelper->executeDispatch(rDispatchProvider,
				    OUString( RTL_CONSTASCII_USTRINGPARAM(".uno:ToggleMergeCells")),
				    OUString( RTL_CONSTASCII_USTRINGPARAM("")),
				    0, args4);
#endif  //_TEST_WRITE

				if ( Col_no == 1 && Row_no == 1 ) {
					//セル選択範囲が1つしかない場合はマージとはしない
					hyo[0].merge[AR_FLAG] = 0;
				} else {
					if ( hyo[ih*Col_no+iw].merge[AR_FLAG] == 0 ) {
						Reference<XSheetCellRange> xCellRange (ClCell, UNO_QUERY);

						Reference<XSheetCellCursor> rClCursor = rSpSheet->createCursorByRange(xCellRange);//消すな　

						rClCursor->collapseToMergedArea();

//                     AR_LEFT         AR_RIGH       AR_TOP       AR_BOTTOM
//wchar_t *mrgside[] = { L"StartColumn", L"EndColumn", L"StartRow", L"EndRow" };
						Reference<XCellRangeAddressable> rCellRangeAddr (rClCursor, UNO_QUERY);
						CellRangeAddress rRangeAddress = rCellRangeAddr->getRangeAddress();
						mrg_wk[AR_LEFT]   = rRangeAddress.StartColumn;
						mrg_wk[AR_RIGHT]  = rRangeAddress.EndColumn;
						mrg_wk[AR_TOP]    = rRangeAddress.StartRow;
						mrg_wk[AR_BOTTOM] = rRangeAddress.EndRow;

						if ( ( mrg_wk[AR_LEFT] != mrg_wk[AR_RIGHT] ) || ( mrg_wk[AR_TOP] != mrg_wk[AR_BOTTOM] ) ) {
							for(ix=0; ix<4; ix++) {
								hyo[ih*Col_no+iw].merge[ix] = mrg_wk[ix];
							}
							if ( (mrg_wk[AR_RIGHT] > Col_no) || (mrg_wk[AR_BOTTOM] > Row_no) ) {
								irc = CalcEnd();
								FreeArea();
								return 2;//起こらないはず
							}
							for ( iw2=mrg_wk[AR_LEFT]; iw2<=mrg_wk[AR_RIGHT]; iw2++ ) {
								for ( ih2=mrg_wk[AR_TOP]; ih2<=mrg_wk[AR_BOTTOM]; ih2++ ) {
									if ( iw2 == mrg_wk[AR_LEFT] ) {
										hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 1;
									} else if ( iw2 == mrg_wk[AR_RIGHT] ) {
										hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 3;
									} else {
										hyo[ih2*Col_no+iw2].merge[AR_FLAG] = 2;
									}
									if ( ih2 == mrg_wk[AR_TOP] ) {
									} else if ( ih2 == mrg_wk[AR_BOTTOM] ) {
										hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 6;
									} else {
										hyo[ih2*Col_no+iw2].merge[AR_FLAG] = hyo[ih2*Col_no+iw2].merge[AR_FLAG] + 3;
									}
									hyo[ih2*Col_no+iw2].merge[AR_BASE] = ih*Col_no+iw;
//									printf("マージ %d %d %d \n", ih2, iw2, hyo[ih2*Col_no+iw2].merge[AR_FLAG]);
								}
							}
						}
					}
//					printf("0 2 1 sheet : %d, column : %d row: %d ...\n",
//						rRangeAddress.Sheet, rRangeAddress.EndColumn-rRangeAddress.StartColumn+1, rRangeAddress.EndRow-rRangeAddress.StartRow+1);
				}
			}
#ifdef _LINUX_PLAT
			Window_Refresh();
#endif  //_LINUX_PLAT
			if ( Break_flag == 1 ) {
				irc = MessageDisp( MSG_CANCLE_CODE );
				irc = CalcEnd();
				FreeArea();
				Break_flag = 2;
				return CANCEL_RETURN;
			}
			ProgressView(30 + (ih * sabun) / 1000);
		}
	}
	catch ( ::cppu::BootstrapException & e ) {
		//	"caught BootstrapException: "
		//	OUStringToOString( e.getMessage(), RTL_TEXTENCODING_ASCII_US ).getStr()
		irc = CalcEnd();
		FreeArea();
		return SDK_ERROR;
	}
	catch ( Exception & e ) {
		//	"caught UNO exception: "
		//	OUStringToOString( e.Message, RTL_TEXTENCODING_ASCII_US ).getStr()
		irc = CalcEnd();
		FreeArea();
		return SDK_ERROR;
	}
	catch (...) {
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		irc = CalcEnd();
		FreeArea();
		return MEMORY_ERROR;
	}

	ProgressView(90);
	if ( CalcEnd() == SDK_ERROR ) return SDK_ERROR;

//printf("結果　文字位置　%d %d \n", (int)hyo[0].h_ichi, (int)hyo[0].v_ichi);

	if ( Break_flag == 1 ) {
		irc = MessageDisp( MSG_CANCLE_CODE );
		FreeArea();
		Break_flag = 2;
		return CANCEL_RETURN;
	}

	return NOMAL_RETURN;//エリアは開放しない
}
#endif  //_SDK
