﻿//*****************************************************************************
//* Copyright (c) 2001-2012 Miday Workshop All rights reserved.
//*
//* File: ClipWrite.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#include <new>
#include <wchar.h>
#include "CalcDef.h"
#include "MsgLocale.h"

#define CALCCLIPID  "ID;PCALC"
#define EXCELCLIPID "ID;PWXL"

//==============================================================================
//クリップボードにデータを出力する
//==============================================================================
int ClipWrite(UNICHAR *wkdata) {
	int irc, ia;
	BOOL irt;
	HANDLE hClip;
	HGLOBAL  hGlobal, hGlobal_p;

	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP1_CODE );
		return FINISHING_MESSAGE;
	}
	irt = EmptyClipboard();
	if ( irt == FALSE ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_CLP2_CODE );
		return FINISHING_MESSAGE;
	}
#ifdef _UNICODE_TABLE
	int sizew = (wcstombs( NULL, (wchar_t*)wkdata, 0)+1) * sizeof(UNICHAR);
	if ( sizew == 0 ) {
		sizew = MTRLEN(wkdata) * 16;//大きめに確保
	}
	hGlobal = GlobalAlloc (GMEM_DDESHARE | GMEM_MOVEABLE, sizew);
#else  //_UNICODE_TABLE
	hGlobal = GlobalAlloc (GMEM_DDESHARE | GMEM_MOVEABLE, MTRLEN(wkdata)+1);
#endif  //_UNICODE_TABLE

	if ( hGlobal == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
	hGlobal_p = (LPTSTR) GlobalLock(hGlobal);
	if ( hGlobal_p == NULL ) {
		irt = CloseClipboard();
		hGlobal_p = GlobalFree(hGlobal);
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
	MTRCPY ( (UNICHAR *)hGlobal_p, MTRLEN(wkdata)+1, wkdata);
	SetLastError(NO_ERROR);
	irt = GlobalUnlock(hGlobal);
	if ( irt == FALSE ) {
		if ( GetLastError() != NO_ERROR ) {
			irt = CloseClipboard();
			hGlobal_p = GlobalFree(hGlobal);
			irc = MessageDisp( MSG_ER_MEM3_CODE );
			return MEMORY_ERROR;
		}
	}
#ifdef _UNICODE_TABLE
	hClip = SetClipboardData(CF_UNICODETEXT, (wchar_t*)hGlobal);
#else  //_UNICODE_TABLE
	hClip = SetClipboardData(CF_TEXT, hGlobal);
#endif  //_UNICODE_TABLE
	if ( hClip == NULL ) {
		irt = CloseClipboard();
		hGlobal_p = GlobalFree(hGlobal);
		irc = MessageDisp( MSG_ER_CLP3_CODE );
		return FINISHING_MESSAGE;
	}
	irt = CloseClipboard();
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP4_CODE );
		return FINISHING_MESSAGE;
	}
//	hGlobal_p = GlobalFree(hGlobal);

	return NOMAL_RETURN;
}

//==============================================================================
//クリップボードからデータを入力する
//==============================================================================
int ClipRead(UNICHAR **wkdata) {
	int irc, ia;
	BOOL irt;
	HGLOBAL  hGlobal, hGlobal_p;

	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP5_CODE );
		return FINISHING_MESSAGE;
	}

#ifdef _UNICODE_TABLE
	hGlobal = GetClipboardData(CF_UNICODETEXT);
#else  //_UNICODE_TABLE
	hGlobal = GetClipboardData(CF_TEXT);
#endif  //_UNICODE_TABLE
	if ( hGlobal == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_CLP6_CODE );
		return FINISHING_MESSAGE;
	}

	hGlobal_p = (LPTSTR) GlobalLock(hGlobal);
	if ( hGlobal_p == NULL ) {
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}

	try{
		*wkdata = new UNICHAR[MTRLEN((UNICHAR *)hGlobal_p)+1];
	}
#if _MSC_VER > 1200
	catch (std::bad_alloc) {
#else  //MSC
//VC6 以下
	catch (...) {
#endif  //MSC
		irt = GlobalUnlock(hGlobal);
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
#if _MSC_VER > 1200
	catch (...) {
		irt = GlobalUnlock(hGlobal);
		irt = CloseClipboard();
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
#endif  //MSC
	MTRCPY ( *wkdata, MTRLEN((UNICHAR *)hGlobal_p)+1, (UNICHAR *)hGlobal_p );
	SetLastError(NO_ERROR);
	irt = GlobalUnlock(hGlobal);
	if ( irt == FALSE ) {
		if ( GetLastError() != NO_ERROR ) {
			FreeArea();
			irt = CloseClipboard();
			irc = MessageDisp( MSG_ER_MEM3_CODE );
			return MEMORY_ERROR;
		}
	}
	irt = CloseClipboard();
	if ( irt == FALSE ) {
		FreeArea();
		irc = MessageDisp( MSG_ER_CLP7_CODE );
		return FINISHING_MESSAGE;
	}

	return NOMAL_RETURN;
}

//==============================================================================
//クリップボードにデータがあるかチェックする
//==============================================================================
int ClipCheck() {
	HGLOBAL  hGlobal,hGlobal_p;
	unsigned int uFormat;
	int  data_type1, data_type2, ia, irc;
	BOOL irt;
	data_type1 = IN_NOTDATA;
	data_type2 = IN_NOTDATA;
	uFormat = 0;
	for(ia=0; ia<ClipWaitCount; ia++) {
		irt = OpenClipboard(hWnd);
		if ( irt == TRUE ) break;
		Sleep(ClipWaitTime);
	}
	if ( irt == FALSE ) {
		irc = MessageDisp( MSG_ER_CLP5_CODE );
		return FINISHING_MESSAGE;
	}

	while((uFormat = EnumClipboardFormats(uFormat)) != 0) {
		if(uFormat == CF_UNICODETEXT ) {
#ifndef _UNICODE_TABLE
			if ( data_type1 != IN_TEXTDATA ) {
#endif  //_UNICODE_TABLE
				data_type1 = IN_UNIDATA;
#ifndef _UNICODE_TABLE
			}
#endif  //_UNICODE_TABLE
		}
		if(uFormat == CF_TEXT ) {
#ifdef _UNICODE_TABLE
			if ( data_type1 != IN_UNIDATA ) {
#endif  //_UNICODE_TABLE
				data_type1 = IN_TEXTDATA;
#ifdef _UNICODE_TABLE
			}
#endif  //_UNICODE_TABLE
		}

		//CF_SYLK(=4)があるとダイアログが表示されないのでチェックする
		//CF_SYLKは、LibreOfficeでもExcelでも作成している
		//CF_SYLKのデータがあれば、作成したソフトをチェックする
		if(uFormat == CF_SYLK ) {
			hGlobal = GetClipboardData(CF_SYLK);
			if ( hGlobal == NULL ) {
				irt = CloseClipboard();
				irc = MessageDisp( MSG_ER_CLP6_CODE );
				return FINISHING_MESSAGE;
			}

			hGlobal_p = (LPTSTR) GlobalLock(hGlobal);
			if ( hGlobal_p == NULL ) {
				irt = CloseClipboard();
				irc = MessageDisp( MSG_ER_MEM3_CODE );
				return MEMORY_ERROR;
			}

			//SYLKのIDがCALCのIDと一致するかチェック(strncmpで比較)
			if ( strncmp((LPCSTR)hGlobal_p, CALCCLIPID, strlen(CALCCLIPID)) == 0 ) {
				data_type2 = IN_CALCDATA;
			}
			//SYLKのIDがEXCELのIDと一致するかチェック(strncmpで比較)
			if ( strncmp((LPCSTR)hGlobal_p, EXCELCLIPID, strlen(EXCELCLIPID)) == 0 ) {
				data_type2 = IN_CALCDATA;
			}

			SetLastError(NO_ERROR);
			irt = GlobalUnlock(hGlobal);
			if ( irt == FALSE ) {
				if ( GetLastError() != NO_ERROR ) {
					FreeArea();
					irt = CloseClipboard();
					irc = MessageDisp( MSG_ER_MEM3_CODE );
					return MEMORY_ERROR;
				}
			}
		}
	}
	CloseClipboard();

	//CF_SYLKがあってCF_TEXTが無いとCalcにペーストするときにエラーとなる
	//LibreOfficeからのコピーでは、両方存在し、CF_SYLKがあってCF_TEXTが無いということは起こらない
	if ( data_type1 == IN_NOTDATA && data_type2 == IN_NOTDATA ) {
		irc = MessageDisp( MSG_ER_CLP8_CODE );//両方存在しない
		return IN_NOTDATA;
	}
	if ( data_type1 == IN_NOTDATA && data_type2 == IN_CALCDATA ) {
		irc = MessageDisp( MSG_ER_CLP9_CODE );//テキストが無い場合
		return IN_NOTDATA;
	}
	if ( (data_type1 == IN_TEXTDATA || data_type1 == IN_UNIDATA ) && data_type2 == IN_CALCDATA ) {
		data_type1 = IN_CALCDATA;
	}
//data_type1 = IN_CALCDATA;//テスト
//if ( data_type1 == IN_CALCDATA ) MessageBoxA(NULL, "CALC", "",0);
	return data_type1;
}
#endif  //_WINDOWS_PLAT
