﻿//*****************************************************************************
//* Copyright (c) 2012-2015 Miday Workshop All rights reserved.
//*
//* File: VersionGet.cpp
//*****************************************************************************
#ifdef _SDK
#ifdef _WINDOWS_PLAT
#include <windows.h>
#include <stdio.h>
#else  //_WINDOWS_PLAT
//#include <gtk/gtk.h>
#include <new>
#include <dirent.h>
#include <stdio.h>
#include <memory.h>
#include <wchar.h>
#include <string.h>
#include <stdint.h>
#include <stdlib.h>
#endif  //_WINDOWS_PLAT

//★★★　Windows SDKでのバージョン取り出し処理は未作成　OLE版のみ公開のため
//★★★　Apache OpenOffice未対応　　　　　　　　　　　rdbファイル未調査のため

#include <memory.h>
#include "CalcDef.h"

UNICHAR OfficeInstPath[FILENAME_SIZE], //Officeがインストールされたパス
        SofficePath[FILENAME_SIZE],    //sofficeのパス
        SofficeRdbPath[FILENAME_SIZE], //offapi.rdbファイルのパス
        SofficeVersion[100],           //バージョン
        SofficeCommand[1000];          //サーバプロセス起動コマンド
UNICHAR SofficeBin[FILENAME_SIZE];//DLLのパス　Path設定ツールで使用　CtoMailやCtoWebでは使用しない

#ifdef _UNICODE_TABLE
#define WPATH1  (wchar_t *)L"C:\\Program Files\\"
#define WPATH2  (wchar_t *)L"LibreOffice"
#define WPATH3  (wchar_t *)L"program"
#define WPATH4  (wchar_t *)L"Basis"
#define WPATH5  (wchar_t *)L"program"
#define WPATH6  (wchar_t *)L"\\URE\\bin"

#define WVKEY1  (wchar_t *)L"version.ini"
#define WVKEY2  (wchar_t *)L"Version"
#define WVKEY3  (wchar_t *)L"ProductMajor"//"OOOBaseVersion"

#define LPATH1A (wchar_t *)L"/usr/lib/"
#define LPATH1B (wchar_t *)L"/usr/lib64/"
#define LPATH1C (wchar_t *)L"/opt/"
#define LPATH2A (wchar_t *)L"libreoffice"
#define LPATH2B (wchar_t *)L"openoffice.org"
#define LPATH3  (wchar_t *)L"program"
#define LPATH4  (wchar_t *)L"basis3.4"
#define LPATH5  (wchar_t *)L"types"

#define LVKEY1  (wchar_t *)L"versionrc"
#define LVKEY2  (wchar_t *)L"Version"
#define LVKEY3  (wchar_t *)L"ProductMajor"//"OOOBaseVersion"

#define VER340  (wchar_t *)L"340"//"3.4"
#define DEFVER1 (wchar_t *)L"100"//"1.0"

#define RDBP1  (wchar_t *)L"URE_MORE_TYPES"
#define RDBP2  (wchar_t *)L"file://"
#define RDBP3  (wchar_t *)L"offapi.rdb"

#define ASTERISK  (wchar_t *)L"*"
#define QUOTATION (wchar_t *)L"\""
#define SEP_URL   (wchar_t *)L"/"
#else  //_UNICODE_TABLE
#define WPATH1  "C:\\Program Files\\"
#define WPATH2  "LibreOffice"
#define WPATH3  "program"
#define WPATH4  "Basis"
#define WPATH5  "program"
#define WPATH6  "\\URE\\bin"

#define WVKEY1  "version.ini"
#define WVKEY2  "Version"
#define WVKEY3  "ProductMajor"//"OOOBaseVersion"

#define LPATH1A "/usr/lib/"
#define LPATH1B "/usr/lib64/"
#define LPATH1C "/opt/"
#define LPATH2A "libreoffice"
#define LPATH2B "openoffice.org"
#define LPATH3  "program"
#define LPATH4  "basis3.4"
#define LPATH5  "types"

#define LVKEY1  "versionrc"
#define LVKEY2  "Version"
#define LVKEY3  "ProductMajor"//"OOOBaseVersion"

#define VER340  "340"//"3.4"
#define DEFVER1 "100"//"1.0"

#define RDBP1  "URE_MORE_TYPES"
#define RDBP2  "file://"
#define RDBP3  "offapi.rdb"

#define ASTERISK  "*"
#define QUOTATION "\""
#define SEP_URL   "/"
#endif  //_UNICODE_TABLE

//==============================================================================
//初期化ファイルよりsofficeのバージョンを取得
//==============================================================================
void SofficeVersion_get() {
	UNICHAR data[FILENAME_SIZE];

#ifdef _WINDOWS_PLAT
	MTRCPY(data, sizeof(data), SofficePath);
	MTRCAT(data, sizeof(data), SEP_S);
	MTRCAT(data, sizeof(data), WVKEY1);

#ifdef _UNICODE_TABLE
	GetPrivateProfileStringW(WVKEY2, WVKEY3,  DEFVER1, SofficeVersion, sizeof(SofficeVersion), data);
#else  //_UNICODE_TABLE
	GetPrivateProfileStringA(WVKEY2, WVKEY3,  DEFVER1, SofficeVersion, sizeof(SofficeVersion), data);
#endif  //_UNICODE_TABLE

#else  //_WINDOWS_PLAT

	MTRCPY(data, sizeof(data), SofficePath);
	MTRCAT(data, sizeof(data), SEP_S);
	MTRCAT(data, sizeof(data), LVKEY1);

	GetProfileWrapp(0, data, LVKEY2, LVKEY3, DEFVER1, SofficeVersion, sizeof(SofficeVersion));
	GetProfileWrapp(2, NULL, NULL, NULL, NULL, NULL, 0);
#endif  //_WINDOWS_PLAT
}

//==============================================================================
//sofficeのパスとバージョン番号を取り出す
//==============================================================================
int Soffice_Path_get() {
//戻り値　=0 V3.4未満　=1 V3.4以上
	UNICHAR ver[100];
	int type;
	int ia, is;

#ifdef _UNICODE_TABLE
#ifdef _VO40                         //OpenOffice
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"400");
	type = 0;
#elif _VO34
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"340");
	type = 0;
#elif _VL44                         //LibreOffice
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"440");
	type = 1;
#elif _VL43
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"430");
	type = 1;
#elif _VL42
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"420");
	type = 1;
#elif _VL41
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"410");
	type = 1;
#elif _VL40
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"400");
	type = 1;
#elif _VL36
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"360");
	type = 1;
#elif _VL35
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"350");
	type = 1;
#elif _VL34
	MTRCPY(ver, sizeof(ver), (wchar_t*)L"340");
	type = 1;
#endif  //_VL40
#else  //_UNICODE_TABLE
#ifdef _VO40                         //OpenOffice
	MTRCPY(ver, sizeof(ver), "400");
	type = 0;
#elif _VO34
	MTRCPY(ver, sizeof(ver), "340");
	type = 0;
#elif _VL44                         //LibreOffice
	MTRCPY(ver, sizeof(ver), "440");
	type = 1;
#elif _VL43
	MTRCPY(ver, sizeof(ver), "430");
	type = 1;
#elif _VL42
	MTRCPY(ver, sizeof(ver), "420");
	type = 1;
#elif _VL41
	MTRCPY(ver, sizeof(ver), "410");
	type = 1;
#elif _VL40
	MTRCPY(ver, sizeof(ver), "400");
	type = 1;
#elif _VL36
	MTRCPY(ver, sizeof(ver), "360");
	type = 1;
#elif _VL35
	MTRCPY(ver, sizeof(ver), "350");
	type = 1;
#elif _VL34
	MTRCPY(ver, sizeof(ver), "340");
	type = 1;
#endif  //_VL40
#endif  //_UNICODE_TABLE

#ifdef _DUMP
#ifdef _UNICODE_TABLE
	if ( type == 0 ) {
//printf ("このパッケージは、Apache OpenOffice バージョン %lc.%lc で動作します。\n\n", ver[0], ver[1] );
	} else {
printf ("このパッケージは、LibreOffice バージョン %lc.%lc で動作します。\n\n", ver[0], ver[1] );
	}
#else  //_UNICODE_TABLE
	if ( type == 0 ) {
//printf ("このパッケージは、Apache OpenOffice バージョン %c.%c で動作します。\n\n", ver[0], ver[1] );
	} else {
printf ("このパッケージは、LibreOffice バージョン %c.%c で動作します。\n\n", ver[0], ver[1] );
	}
#endif  //_UNICODE_TABLE
#endif  //_DUMP

	if ( MTRCMP(SofficePath, LIT_NULL_S) == 0 ) {
		is = 0;
	} else {
		is = 1;
	}

#ifdef _WINDOWS_PLAT
	UNICHAR data[FILENAME_SIZE];
//------------------------------------------------------------------------------
//libreoffice実行ファイルのパスを取得
//------------------------------------------------------------------------------
#ifdef _UNICODE_TABLE
	WIN32_FIND_DATAW FindFileData;
#else  //_UNICODE_TABLE
	WIN32_FIND_DATA FindFileData;
#endif  //_UNICODE_TABLE
	HANDLE hndl;

	if ( is == 0 ) {//初期化ファイルには定義されていない
		ia = 0;
		MTRCPY(SofficePath, sizeof(SofficePath), WPATH1 );
		MTRCPY(data, sizeof(data), SofficePath );
		MTRCAT(data, sizeof(data), ASTERISK );
#ifdef _UNICODE_TABLE
		hndl = FindFirstFileW(data, &FindFileData);
#else  //_UNICODE_TABLE
		hndl = FindFirstFileA(data, &FindFileData);
#endif  //_UNICODE_TABLE
//		hndl = FindFirstFileEx( filename, FindExInfoStandard, &FindFileData, FindExSearchNameMatch, NULL, 0 );
		if ( hndl != INVALID_HANDLE_VALUE ) {
			for (;;) {
				if ( MTRNCMP(FindFileData.cFileName, WPATH2, MTRLEN(WPATH2)) == 0 ) {
					MTRCAT(SofficePath, sizeof(SofficePath), FindFileData.cFileName );
					MTRCPY(SofficeRdbPath, sizeof(SofficeRdbPath), SofficePath );
					MTRCPY(SofficeBin, sizeof(SofficeBin), SofficePath );
					MTRCAT(SofficeBin, sizeof(SofficeBin), WPATH6 );
					MTRCAT(SofficePath, sizeof(SofficePath), SEP_S );
					MTRCAT(SofficePath, sizeof(SofficePath), WPATH3 );

//------------------------------------------------------------------------------
//初期化ファイルよりバージョンを取得
//------------------------------------------------------------------------------
					SofficeVersion_get();

					if(MTRCMP(ver, SofficeVersion) == 0) {
						ia = 1;
						break;
					}
				}
#ifdef _UNICODE_TABLE
				if ( FindNextFileW(hndl, &FindFileData) == FALSE ) break;
#else  //_UNICODE_TABLE
				if ( FindNextFileA(hndl, &FindFileData) == FALSE ) break;
#endif  //_UNICODE_TABLE
			}
		} else {
			FindClose(hndl);
			return -1;
		}
		FindClose(hndl);
		if ( ia == 0 ) {
#ifdef _DUMP
printf ("Officeが見つかりませんでした\n");//windows  init file not found
#endif  //_DUMP
			return -1;
		}
	}
#ifdef _DUMP
#ifdef _UNICODE_TABLE
printf ("Office パス\n  %ls\n", SofficePath);
#else  //_UNICODE_TABLE
printf ("Office パス\n  %s\n", SofficePath);
#endif  //_UNICODE_TABLE
#endif  //_DUMP

//------------------------------------------------------------------------------
//初期化ファイルよりバージョンを取得
//------------------------------------------------------------------------------
	SofficeVersion_get();

#ifdef _DUMP
#ifdef _UNICODE_TABLE
printf ("Office バージョン\n  %lc.%ls\n", SofficeVersion[0], &SofficeVersion[1] );
#else  //_UNICODE_TABLE
printf ("Office バージョン\n  %c.%s\n", SofficeVersion[0], &SofficeVersion[1] );
#endif  //_UNICODE_TABLE
#endif  //_DUMP

//------------------------------------------------------------------------------
//rdbファイルのバスを取得(SofficeRdbPathの区切り記号は/)
//------------------------------------------------------------------------------
	if ( is == 0 && MTRCMP(SofficeVersion, VER340) >= 0 ) {//初期化ファイルには定義されていない
		ia = 0;
		MTRCPY(data, sizeof(data), SofficeRdbPath );
		MTRCAT(data, sizeof(data), SEP_S );
		MTRCAT(data, sizeof(data), ASTERISK );
		MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), SEP_URL );
#ifdef _UNICODE_TABLE
		hndl = FindFirstFileW(data, &FindFileData);
#else  //_UNICODE_TABLE
		hndl = FindFirstFileA(data, &FindFileData);
#endif  //_UNICODE_TABLE
//		hndl = FindFirstFileEx( filename, FindExInfoStandard, &FindFileData, FindExSearchNameMatch, NULL, 0 );
		if ( hndl != INVALID_HANDLE_VALUE ) {
			for (;;) {
				if ( MTRNCMP(FindFileData.cFileName, WPATH4, MTRLEN(WPATH4)) == 0 ||
				     MTRNCMP(FindFileData.cFileName, WPATH3, MTRLEN(WPATH3)) == 0 ) {
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), FindFileData.cFileName );
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), SEP_URL );
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), WPATH5 );
					ia = 1;
					break;
				}
#ifdef _UNICODE_TABLE
				if ( FindNextFileW(hndl, &FindFileData) == FALSE ) break;
#else  //_UNICODE_TABLE
				if ( FindNextFileA(hndl, &FindFileData) == FALSE ) break;
#endif  //_UNICODE_TABLE
			}
		} else {
			FindClose(hndl);
			return -1;
		}
		FindClose(hndl);
		if ( ia == 0 ) {
#ifdef _DUMP
printf ("Officeが見つかりませんでした\n");//windows  (init file not found) & (3.5 or later version)
#endif  //_DUMP
			return -1;
		}
		SofficeRdbPath[2] = '/';
		SofficeRdbPath[MTRLEN(WPATH1)-1] = '/';
	}

	if ( MTRCMP(SofficeVersion, VER340) >= 0 ) {
//irc = MessageBox( hWnd, SofficePath, SofficeVersion, MB_OK | MB_ICONSTOP );
		return 1;
	} else {
		return 0;
	}
#else  //_WINDOWS_PLAT

	int ib;
	DIR *dp;
	struct dirent *p;
	UNICHAR data[FILENAME_SIZE];
	UNICHAR pathw[FILENAME_SIZE];
	UNICHAR *filenamew, *filenamew2;
	int sizew, sizew2;

//------------------------------------------------------------------------------
//libreoffice実行ファイルのパスを取得
//------------------------------------------------------------------------------
	if ( is == 0 ) {//初期化ファイルには定義されていない
		ia = 0;
		for(ib=0; ib<3; ib++) {
			if ( ib == 0 ) {
				MTRCPY(pathw, sizeof(SofficePath), LPATH1A );
			} else if ( ib == 1 ) {
				MTRCPY(pathw, sizeof(SofficePath), LPATH1B );
			} else {
				MTRCPY(pathw, sizeof(SofficePath), LPATH1C );
			}
#ifdef _UNICODE_TABLE
			if ((dp = wopendir(pathw)) == NULL) continue;
#else  //_UNICODE_TABLE
			if ((dp = opendir(pathw)) == NULL) continue;
#endif  //_UNICODE_TABLE
			for (;;) {
				p = readdir(dp);
				if (p == NULL) break;
#ifdef _UNICODE_TABLE
				sizew = mbstowcs( NULL, p->d_name, 0);
				if ( sizew == -1 ) {
					closedir(dp);
					return -1;
				}
				try{
					filenamew = new UNICHAR[sizew+1];
				}
				catch (...) {
					closedir(dp);
					return -1;
				}
				sizew2 = mbstowcs( filenamew, p->d_name, sizew);
				filenamew[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
				try{
					filenamew = new UNICHAR[MTRLEN(p->d_name)+1];
				}
				catch (...) {
					closedir(dp);
					return -1;
				}
				MTRCPY(filenamew, strlen(p->d_name), p->d_name);
#endif  //_UNICODE_TABLE
				//Libreoffice
				if ( type == 1 && MTRNCMP(filenamew, LPATH2A, MTRLEN(LPATH2A)) == 0 ) {
					try{
						filenamew2 = new UNICHAR[sizew+1];
					}
					catch (...) {
						delete[] filenamew;
						closedir(dp);
						return -1;
					}
					MTRCPY(filenamew2, sizeof(filenamew2), filenamew);

					MTRCPY(SofficePath, sizeof(SofficePath), pathw );
					MTRCAT(SofficePath, sizeof(SofficePath), filenamew2 );
					MTRCPY(SofficeRdbPath, sizeof(SofficeRdbPath), SofficePath );
					MTRCPY(OfficeInstPath, sizeof(OfficeInstPath), SofficePath );
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), SEP_S );
					MTRCAT(SofficePath, sizeof(SofficePath), SEP_S );
					MTRCAT(SofficePath, sizeof(SofficePath), LPATH3 );
					delete[] filenamew2;

//------------------------------------------------------------------------------
//初期化ファイルよりバージョンを取得
//------------------------------------------------------------------------------
					SofficeVersion_get();

//					if(MTRCMP(ver, SofficeVersion) == 0) {
					///opt/libreoffice4.4/program/versionrc で
					//ProductMajor=40 となっている
					if((MTRCMP(ver, SofficeVersion) == 0) ||
					   (MTRCMP(ver, L"440") == 0 && MTRCMP(SofficeVersion, L"40") == 0)) {//4.4のバグ??
						ia = 1;
						break;
					}
				}
				//openoffice 後ほど復活
/*				if ( type == 0 && MTRNCMP(filenamew, LPATH2B, MTRLEN(LPATH2B)) == 0 ) {
				}*/
				delete[] filenamew;
				if(ia == 1 ) break;
			}
			closedir(dp);
			if(ia == 1 ) break;
		}
		if (ia == 0) {
#ifdef _DUMP
printf ("Officeが見つかりませんでした\n");//linux  init file not found
#endif  //_DUMP
			return -1;
		}
#ifdef _DUMP
printf ("Office バージョン\n  %lc.%ls\n", SofficeVersion[0], &SofficeVersion[1] );
#endif  //_DUMP

	} else {
//------------------------------------------------------------------------------
//初期化ファイルよりバージョンを取得
//------------------------------------------------------------------------------
		SofficeVersion_get();
#ifdef _DUMP
//EnvTestでは、初期化ファイルから読み込まないので、このブロックを通らない
//printf ("ini ファイルに定義されているパスのバージョンです。\n");
printf ("Office バージョン\n  %lc.%ls\n", SofficeVersion[0], &SofficeVersion[1] );
#endif  //_DUMP
	}

//	if (ia == 0) {
//#ifdef _DUMP
//printf ("Office not found\n");
//#endif  //_DUMP
//		return -1;
//	}

#ifdef _DUMP
printf ("Office バス\n  %ls\n", SofficePath);
#endif  //_DUMP

//------------------------------------------------------------------------------
//rdbファイルのバスを取得
//------------------------------------------------------------------------------
//  /usr/lib/libreoffice/program/types/offapi.rdb       3.5
//  /usr/lib/libreoffice/basis3.4/program/offapi.rdb    3.4
//  /usr/lib/libreoffice/basis3.3/program/offapi.rdb    3.3(多分 但し3.3は、SofficeRdbPathを使わない)

	if ( is == 0 && MTRCMP(SofficeVersion, VER340) >= 0 ) {//初期化ファイルには定義されていない
#ifdef _UNICODE_TABLE
		if ((dp = wopendir(SofficeRdbPath)) == NULL) return -1;
#else  //_UNICODE_TABLE
		if ((dp = opendir(SofficeRdbPath)) == NULL) return -1;
#endif  //_UNICODE_TABLE
		ia = 0;
		for (;;) {
			p = readdir(dp);
			if (p == NULL) break;
#ifdef _UNICODE_TABLE
			sizew = mbstowcs( NULL, p->d_name, 0);
			if ( sizew == -1 ) {
				closedir(dp);
				return -1;
			}
			try{
				filenamew = new UNICHAR[sizew+1];
			}
			catch (...) {
				closedir(dp);
				return -1;
			}
			sizew2 = mbstowcs( filenamew, p->d_name, sizew);
			filenamew[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
			try{
				filenamew = new UNICHAR[MTRLEN(p->d_name)+1];
			}
			catch (...) {
				closedir(dp);
				return -1;
			}
			MTRCPY(filenamew, strlen(p->d_name), p->d_name);
#endif  //_UNICODE_TABLE
			if ( MTRNCMP(filenamew, LPATH4, MTRLEN(LPATH4)) == 0 ) {//3.4の場合
				MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), filenamew );
				MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), SEP_S );
				MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), LPATH3 );
				delete[] filenamew;
				ia = 1;
				break;
			}
			if ( MTRNCMP(filenamew, LPATH3, MTRLEN(LPATH3)) == 0 ) {//3.5の場合
				if ( MTRNCMP(SofficeVersion, VER340, MTRLEN(VER340)) > 0 ) {//3.5以上　3.6で変更要かも?
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), LPATH3 );
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), SEP_S );
					MTRCAT(SofficeRdbPath, sizeof(SofficeRdbPath), LPATH5 );
					delete[] filenamew;
					ia = 1;
					break;
				}
			}
			delete[] filenamew;
		}
		closedir(dp);

		if (ia == 0) {
#ifdef _DUMP
printf ("Officeが見つかりませんでした\n");//linux  init file found
#endif  //_DUMP
			return -1;
		}
	}

	if ( MTRCMP(SofficeVersion, VER340) >= 0 ) {
//irc = MessageBox( hWnd, SofficePath, SofficeVersion, MB_OK | MB_ICONSTOP );
		return 1;
	} else {
		return 0;
	}
#endif  //_WINDOWS_PLAT
}

//==============================================================================
//  rdbファイルがあるかチェックする バージョン3.4未満
//==============================================================================
int RdbCheck() {
//戻り値　=0 なし　=1 あり
	UNICHAR filename[FILENAME_SIZE];
#ifdef _WINDOWS_PLAT
	HANDLE hndl;

	int ib;

#ifdef _UNICODE_TABLE
	WIN32_FIND_DATAW FindFileData;
#else  //_UNICODE_TABLE
	WIN32_FIND_DATA FindFileData;
#endif  //_UNICODE_TABLE
	MTRCPY(filename, sizeof(filename), AppPath);
	MTRCAT(filename, sizeof(filename), SEP_S);
	MTRCAT(filename, sizeof(filename), LIT_RDB_FILEW);

#ifdef _UNICODE_TABLE
	hndl = FindFirstFileW(filename, &FindFileData);
#else  //_UNICODE_TABLE
	hndl = FindFirstFileA(filename, &FindFileData);
#endif  //_UNICODE_TABLE
//	hndl = FindFirstFileEx( filename, FindExInfoStandard, &FindFileData, FindExSearchNameMatch, NULL, 0 );
	if ( hndl != INVALID_HANDLE_VALUE ) {
		ib = 1;
	} else {
		ib = 0;
	}
	FindClose(hndl);

#else  //_WINDOWS_PLAT
	DIR *dp;
	int ib;
	struct dirent *p;
	UNICHAR *filenamew;
	int sizew, sizew2;

	ib = 0;
	MTRCPY(filename, sizeof(filename), AppPath);
	MTRCAT(filename, sizeof(filename), SEP_S);
#ifdef _UNICODE_TABLE
	if ((dp = wopendir(filename)) == NULL) return 0;
#else  //_UNICODE_TABLE
	if ((dp = opendir(filename)) == NULL) return -1;
#endif  //_UNICODE_TABLE
	for (;;) {
		p = readdir(dp);
		if (p == NULL) break;
#ifdef _UNICODE_TABLE
		sizew = mbstowcs( NULL, p->d_name, 0);
		if ( sizew == -1 ) {
			closedir(dp);
			return 0;//ファイル無し
		}
		try{
			filenamew = new UNICHAR[sizew+1];
		}
		catch (...) {
			closedir(dp);
			return 0;
		}
		sizew2 = mbstowcs( filenamew, p->d_name, sizew);
		filenamew[sizew] = LIT_NULL_C;
#else  //_UNICODE_TABLE
		try{
			filenamew = new UNICHAR[MTRLEN(p->d_name)+1];
		}
		catch (...) {
			closedir(dp);
			return 0;
		}
		MTRCPY(filenamew, strlen(p->d_name), p->d_name);
#endif  //_UNICODE_TABLE
		if ( MTRNCMP(filenamew, LIT_RDB_FILEW, MTRLEN(LIT_RDB_FILEW)) == 0 ) {
			ib = 1;
		}
		delete[] filenamew;
	}
	closedir(dp);
#endif  //_WINDOWS_PLAT
	return ib;
}

//==============================================================================
//  環境変数をチェックして、無ければ設定する バージョン3.4以上
//==============================================================================
void EnvSet() {
	UNICHAR parm[FILENAME_SIZE];

#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	GetEnvironmentVariableW(RDBP1, parm, sizeof(parm));
#else  //_UNICODE_TABLE
	GetEnvironmentVariableA(RDBP1, parm, sizeof(parm));
#endif  //_UNICODE_TABLE
//	if ( strcmp(parm, "") == 0 ) {
		MTRCPY(parm, sizeof(parm), RDBP2);
		MTRCAT(parm, sizeof(parm), SEP_URL);
		MTRCAT(parm, sizeof(parm), SofficeRdbPath);
		MTRCAT(parm, sizeof(parm), SEP_URL);
		MTRCAT(parm, sizeof(parm), RDBP3);
#ifdef _UNICODE_TABLE
		SetEnvironmentVariableW(RDBP1, parm);
#else  //_UNICODE_TABLE
		SetEnvironmentVariableA(RDBP1, parm);
#endif  //_UNICODE_TABLE
//	}
#else  //_WINDOWS_PLAT
//	if ( strcmp(getenv(RDBP1), "") == 0 ) {
		MTRCPY(parm, sizeof(parm), RDBP2);
		MTRCAT(parm, sizeof(parm), SofficeRdbPath);
		MTRCAT(parm, sizeof(parm), SEP_URL);
		MTRCAT(parm, sizeof(parm), RDBP3);
#ifdef _UNICODE_TABLE
		wsetenv(RDBP1, parm, 1);
#else  //_UNICODE_TABLE
		setenv(RDBP1, parm, 1);
#endif  //_UNICODE_TABLE
//	}
#endif  //_WINDOWS_PLAT
#ifdef _DUMP
#ifdef _UNICODE_TABLE
printf ("offapi.rdb バス\n  %ls  %ls\n", RDBP1, parm);
#else  //_UNICODE_TABLE
printf ("offapi.rdb バス\n  %s  %s\n", RDBP1, parm);
#endif  //_UNICODE_TABLE
#endif  //_DUMP
}

//==============================================================================
//  サーバーを起動する
//==============================================================================
int ServerRun(UNICHAR *param) {

#ifdef _WINDOWS_PLAT
	MTRCPY(SofficeCommand, sizeof(SofficeCommand), QUOTATION);
#else  //_WINDOWS_PLAT
	SofficeCommand[0] = LIT_NULL_C;
#endif  //_WINDOWS_PLAT
	MTRCAT(SofficeCommand, sizeof(SofficeCommand), SofficePath);
	MTRCAT(SofficeCommand, sizeof(SofficeCommand), SEP_S);
	MTRCAT(SofficeCommand, sizeof(SofficeCommand), param);

#ifdef _WINDOWS_PLAT
#ifdef _UNICODE_TABLE
#ifndef _DUMP
	PROCESS_INFORMATION PI;
	STARTUPINFOW SI;
	GetStartupInfoW(&SI);
	if ( CreateProcessW(NULL, SofficeCommand, NULL, NULL, false,  CREATE_DEFAULT_ERROR_MODE,NULL, SofficePath, &SI, &PI) ) {
	}
#endif  //_DUMP
#else  //_UNICODE_TABLE
#ifndef _DUMP
	PROCESS_INFORMATION PI;
	STARTUPINFO SI;
	GetStartupInfoA(&SI);
	if ( CreateProcessA(NULL, SofficeCommand, NULL, NULL, false,  CREATE_DEFAULT_ERROR_MODE,NULL, SofficePath, &SI, &PI) ) {
	}
#endif  //_DUMP
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	MTRCAT(SofficeCommand, sizeof(SofficeCommand), (wchar_t*)L" &");
#ifndef _DUMP
	wsystem(SofficeCommand);
#endif  //_DUMP
#else  //_UNICODE_TABLE
	MTRCAT(SofficeCommand, sizeof(SofficeCommand), " &");
#ifndef _DUMP
	system(SofficeCommand);
#endif  //_DUMP
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT

#ifdef _DUMP
#ifdef _UNICODE_TABLE
printf ("サーバー起動コマンド\n  %ls\n", SofficeCommand);
#else  //_UNICODE_TABLE
printf ("サーバー起動コマンド\n  %s\n", SofficeCommand);
#endif  //_UNICODE_TABLE
#endif  //_DUMP
	return 0;
}
#endif  //_SDK

