﻿//*****************************************************************************
//* Copyright (c) 2011-2013 Miday Workshop All rights reserved.
//*
//* File: WinMain.cpp
//*****************************************************************************
#ifdef _WINDOWS_PLAT
#include <windows.h>
#include <commctrl.h>
#include <locale.h>
#pragma comment(lib, "comctl32.lib")
#ifdef _SDK
#include <sal/main.h>
#endif  //_SDK
#include "CalcDef.h"
#include "MsgLocale.h"

#define IDR_MAINFRAME       128
#define IBS_PUSHBUTTON      123

HWND ghwndApp;                  //メインウインドウのハンドル
HANDLE ghaccelTable;            //アクセレータ
HWND hWnd, hWnd2, hWnd3, hWnd4;
//int Key_down_flag;				//キーを押している状態かどうか

//==============================================================================
//ProgressBarの進捗を設定する
//==============================================================================
int ProgressView(int par) {
	int lResult;
	lResult = SendMessage( (HWND)hWnd3, (UINT)PBM_SETPOS, (WPARAM)par, (LPARAM)0);
	return NOMAL_RETURN;
}

//==============================================================================
//スレッドの処理
//==============================================================================
DWORD WINAPI ThreadFunc(LPVOID vdParam) {
	CalcCntl();

	Sleep(200);
	PostMessage(hWnd, WM_CLOSE, NULL, NULL);
	return NOMAL_RETURN;
}

//==============================================================================
//コールバック関数
//==============================================================================
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM IParam) {
	int ia;

	MINMAXINFO *lpMMI = (MINMAXINFO*)IParam; 
	switch(message) {
	case WM_CLOSE:
		DestroyWindow(hWnd);
		break;

	case WM_DESTROY:
		for(ia=0; ia<100; ia++) {//最大10秒まで待つ
			if ( Break_flag != 1 ) {
				PostQuitMessage(0);
				break;
			}
			Sleep(100);
		}
		break;

	case WM_KEYDOWN:
		switch(LOWORD(wParam)) {
		case VK_RETURN://エンターキー
		case VK_SPACE://スペースーキー
		case VK_ESCAPE://エスケープキー
//			Key_down_flag = 1;
			Break_flag    = 1;//長く押し続けていると処理が終わってしまう場合があるので keydown でキャンセルとする
			break;
		}
		break;

//	case WM_KEYUP:
//		switch(LOWORD(wParam)) {
//		case VK_RETURN://エンターキー
//		case VK_SPACE://スペースーキー
//		case VK_ESCAPE://エスケープキー
//			if ( Key_down_flag == 1 ) {
//				Break_flag    = 1;
//			}
//			Key_down_flag = 0;
//			break;
//		}
//		break;

	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IBS_PUSHBUTTON://終了
			Break_flag = 1;
			break;
		}
		break;

	default:
		return(DefWindowProc(hWnd, message, wParam, IParam));
	}
	return NOMAL_RETURN;
}

//==============================================================================
//アプリケーションの初期化
//==============================================================================
BOOL InitApplication(HANDLE hInstance) {
	WNDCLASS wndclass;   // Windows のクラスを登録するのに使う構造体

	wndclass.style         = (unsigned int)NULL;
	wndclass.lpfnWndProc   = WndProc;
	wndclass.cbClsExtra    = 0;
	wndclass.cbWndExtra    = 0;
	wndclass.hInstance     = (struct HINSTANCE__ *)hInstance;
	wndclass.hIcon         = LoadIcon((struct HINSTANCE__ *)hInstance, MAKEINTRESOURCE(IDR_MAINFRAME));//"MsgCopy");
	wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)( COLOR_BTNSHADOW );
	wndclass.lpszMenuName  = MAKEINTRESOURCE(IDR_MAINFRAME);//NULL;
	wndclass.lpszClassName = "NothingWClass";

//	Key_down_flag = 0;

	return( RegisterClass( &wndclass ) );
}

//==============================================================================
//オブジェクトの削除
//==============================================================================
VOID MaybeDeleteObject(HGDIOBJ * phgdi) {
	if (*phgdi == NULL)
		return;

	DeleteObject(*phgdi);
	*phgdi = NULL;	
}

//==============================================================================
//インスタンスの初期化
//==============================================================================
BOOL InitInstance(HANDLE hInstance, int nCmdShow) {
	int xl, xw, yt, yh;
	int lResult;

#ifdef _UNICODE_TABLE
	LOGFONTW    lf;
#else  //_UNICODE_TABLE
	LOGFONTA    lf;
#endif  //_UNICODE_TABLE
	HFONT      hfont;
	HFONT ghfontEntry;

	Break_flag   = 0;
	Allline_flag = 0;

	InitCommonControls();

	xl = (GetSystemMetrics(SM_CXFULLSCREEN) - 260)/2;
	yt = (GetSystemMetrics(SM_CYFULLSCREEN) - 130)/2;
	hWnd = CreateWindow( "NothingWClass", APP_NAME,
			WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
			xl, yt, 260, 130, NULL, NULL, (struct HINSTANCE__ *)hInstance, NULL);
	if ( ! hWnd ) return( FALSE );

	xl = 10; xw = 272; yt = 7; yh = 16;
	ShowWindow( hWnd, nCmdShow );
	hWnd2 = CreateWindow( "STATIC", WIN_MSG,
			WS_CHILD | WS_VISIBLE  | //WS_TABSTOP | //WS_BORDER |
			NULL,
			xl, yt, xw, yh, hWnd, NULL, (struct HINSTANCE__ *)hInstance, NULL);
	xl = 30; xw = 200; yt = 30; yh = 20;
	hWnd3 = CreateWindow( PROGRESS_CLASS, NULL,
			WS_CHILD | WS_VISIBLE  | //WS_TABSTOP | //WS_BORDER |
			NULL,
			xl, yt, xw, yh, hWnd, NULL, (struct HINSTANCE__ *)hInstance, NULL);
	lResult = SendMessage( (HWND)hWnd3, (UINT)PBM_SETRANGE, (WPARAM)0, (LPARAM)MAKELPARAM(0,100));
//	lResult = SendMessage( (HWND)hWnd3, (UINT)PBM_SETSTEP, (WPARAM)10, (LPARAM) 0);
//	lResult = SendMessage( (HWND)hWnd3, (UINT)PBM_STEPIT, (WPARAM)0, (LPARAM)0);
	xl = 80; xw = 86; yt = 65; yh = 20;
	hWnd4 = CreateWindow( "BUTTON", WIN_BTN,
			WS_CHILD | WS_VISIBLE | //WS_TABSTOP | //WS_BORDER | ボタンへはタブで移動しない
			BS_DEFPUSHBUTTON,
			xl, yt, xw, yh, hWnd, (HMENU)IBS_PUSHBUTTON, (struct HINSTANCE__ *)hInstance, NULL);

	SetFocus(hWnd);

	DWORD dwID;
	CreateThread(NULL, 0, ThreadFunc, (LPVOID)hWnd, 0, &dwID);

///////////
//	ClearStruct(&cf);
//	cf.lStructSize = sizeof(CHOOSEFONT);
//	cf.hwndOwner = hWnd;
//	cf.lpLogFont = &lf;
//	cf.Flags = CF_SCREENFONTS | CF_EFFECTS;

	lf.lfHeight = -11;
	lf.lfWidth = 0;
	lf.lfEscapement = 0;
	lf.lfOrientation = 0;
	lf.lfWeight = 700;
	lf.lfItalic = 0;
	lf.lfUnderline = 0;
	lf.lfStrikeOut = 0;
	lf.lfCharSet= 128;
	lf.lfOutPrecision = 3;
	lf.lfClipPrecision = 2;
	lf.lfQuality = 1;
	lf.lfPitchAndFamily = 18;
	MTRCPY ( lf.lfFaceName, LF_FACESIZE, FONT_NAME );
	hfont= CreateFontIndirect((CONST LOGFONTA*)&lf);
	if (hfont == NULL)
		return(FALSE);

	MaybeDeleteObject((void **)&ghfontEntry);
	ghfontEntry = hfont;
	SendMessage(hWnd2, WM_SETFONT,	(WPARAM) ghfontEntry, MAKELPARAM(TRUE, 0));
	SendMessage(hWnd3, WM_SETFONT,	(WPARAM) ghfontEntry, MAKELPARAM(TRUE, 0));
	SendMessage(hWnd4, WM_SETFONT,	(WPARAM) ghfontEntry, MAKELPARAM(TRUE, 0));

//	UpdateWindow(hWnd);
	return(TRUE);
}

//==============================================================================
//メイン関数
//==============================================================================
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPreInstance,
					LPSTR lpCmdLine, int nCmdShow) {

	MSG msg;
	int ia, ix;

#ifdef _SDK
	SofficePath[0]    = LIT_NULL_C;
	SofficeRdbPath[0] = LIT_NULL_C;
#endif  //_SDK

#ifdef _UNICODE_TABLE
	_wsetlocale( LC_CTYPE, LIT_NULL_S );//ロケール設定
#else  //_UNICODE_TABLE
//	setlocale( LC_CTYPE, LIT_NULL_S );//ロケール設定
#endif  //_UNICODE_TABLE

//------------------------------------------------------------------------------
//パスの取得
//------------------------------------------------------------------------------
#ifdef _UNICODE_TABLE
	GetModuleFileNameW(NULL, AppPath, sizeof(AppPath)-1 );
#else  //_UNICODE_TABLE
	GetModuleFileNameA(NULL, AppPath, sizeof(AppPath)-1 );
#endif  //_UNICODE_TABLE
	for(ia=MTRLEN(AppPath); ia>0; ia--) {
		if ( AppPath[ia] == SEP_C ) {
			AppPath[ia] = LIT_NULL_C;
			break;
		}
	}

//------------------------------------------------------------------------------
//初期化ファイルを調べる
//------------------------------------------------------------------------------
#if defined(_WIKI) || defined(_HTML)
	int irx;
	if ( FileSizeGet(AppPath, INIFILE) <= 0 ) {
		irx = MessageDisp( MSG_ER_INIT_CODE );
	}
#endif  //_WIKI \HTML

	MTRCPY(Inifile, sizeof(Inifile), AppPath);
	MTRCAT(Inifile, sizeof(Inifile), SEP_S);
	MTRCAT(Inifile, sizeof(Inifile), INIFILE);

	ix = ProfileGet(Inifile);

#ifdef _UNICODE_TABLE
	if ( MTRCMP( Locale, LIT_NULL_S ) != 0 ) {
		_wsetlocale( LC_CTYPE, Locale );//ロケール設定
	}
#else  //_UNICODE_TABLE
	setlocale( LC_CTYPE, "" );//ロケール設定
#endif  //_UNICODE_TABLE

//------------------------------------------------------------------------------
//環境変数設定　バージョン3.4以上の場合
//------------------------------------------------------------------------------
#ifdef _SDK
	int irc;

	//バージョンチェック
	Verno = Soffice_Path_get();
	if ( Verno >= 1 ) {//3.4以上
		EnvSet();
	} else if ( Verno == 0 ) {//バージョン3.4未満の場合
		if ( RdbCheck() != 1 ) {
			irc = MessageDisp( MSG_ER_RDB_CODE );//rdbファイルが無い
			return 0;
		}
	} else {
		irc = MessageDisp( MSG_ER_CAL2_CODE );//Calcが見つからない
		return 0;
	}
#endif  //_SDK

	if(!hPreInstance)
		if(!InitApplication(hInstance))
			return (FALSE);
	if(!InitInstance(hInstance, nCmdShow))
		return(FALSE);

	while( GetMessage( &msg, NULL, 0, 0 ) ) {
//		if (!IsDialogMessage(hWnd, &msg)) {
		if (!TranslateAccelerator(ghwndApp, (struct HACCEL__ *)ghaccelTable, &msg)) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return msg.wParam;
}
#endif  //_WINDOWS_PLAT

