//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: Regist.cpp
//*****************************************************************************

#include <windows.h>
#include <memory.h>
#include "CalcDef.h"
#include "resource.h"

#ifdef _UNICODE_TABLE
#define SUBKEY L"SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\"
#else
#define SUBKEY "SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\"
#endif

#define REGPATH_SIZE 500

//==============================================================================
//  WXgHKEY_LOCAL_MACHINȄo
//==============================================================================
int GetReg(UNICHAR *pathexe, UNICHAR *pathdll, UNICHAR *exename, int size) {
	HKEY phkResult;
	long ix;
	UNICHAR lpszSubKey[REGPATH_SIZE];
	DWORD pdwType, len;

	MTRCPY( lpszSubKey, sizeof(lpszSubKey), SUBKEY );
	MTRCAT( lpszSubKey, sizeof(lpszSubKey), exename );
#ifdef _UNICODE_TABLE
	ix = RegOpenKeyExW(HKEY_LOCAL_MACHINE, lpszSubKey, 0, KEY_READ | KEY_WRITE, &phkResult);
#else
	ix = RegOpenKeyExA(HKEY_LOCAL_MACHINE, lpszSubKey, 0, KEY_READ | KEY_WRITE, &phkResult);
#endif
	if ( ix == 0 ) {
		len = size;
#ifdef _UNICODE_TABLE
		RegQueryValueExW(phkResult, L"Path", NULL, &pdwType, NULL, &len);
		RegQueryValueExW(phkResult, L"Path", NULL, &pdwType, (BYTE*)pathdll, &len);
		pathdll[len] = L'\0';
		RegQueryValueExW(phkResult, L"", NULL, &pdwType, NULL, &len);
		RegQueryValueExW(phkResult, L"", NULL, &pdwType, (BYTE*)pathexe, &len);
		pathexe[len] = L'\0';
#else
		RegQueryValueExA(phkResult, "Path", NULL, &pdwType, NULL, &len);
		RegQueryValueExA(phkResult, "Path", NULL, &pdwType, (BYTE*)pathdll, &len);
		pathdll[len] = '\0';
		RegQueryValueExA(phkResult, "", NULL, &pdwType, NULL, &len);
		RegQueryValueExA(phkResult, "", NULL, &pdwType, (BYTE*)pathexe, &len);
		pathexe[len] = '\0';
#endif
		ix = RegCloseKey(phkResult);
		return 1;
    } else {
		ix = RegCloseKey(phkResult);
		return 0;
	}
}

//==============================================================================
//  WXgɒǉ
//==============================================================================
int AddReg(UNICHAR *pathexe, UNICHAR *pathdll, UNICHAR *exename) {
	HKEY phkResult;
	long ix;
	UNICHAR lpszSubKey[REGPATH_SIZE];
	DWORD dwDisposition;

	MTRCPY( lpszSubKey, sizeof(lpszSubKey), SUBKEY );
	MTRCAT( lpszSubKey, sizeof(lpszSubKey), exename );
#ifdef _UNICODE_TABLE
	ix = RegCreateKeyExW(HKEY_LOCAL_MACHINE, lpszSubKey, 0, L"", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &phkResult, &dwDisposition);
#else
	ix = RegCreateKeyExA(HKEY_LOCAL_MACHINE, lpszSubKey, 0, "", REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &phkResult, &dwDisposition);
#endif
	if ( ix == ERROR_SUCCESS ) {
#ifdef _UNICODE_TABLE
		RegSetValueExW(phkResult, L"",     0, REG_SZ, (const BYTE *)pathexe, (MTRLEN(pathexe)+1)*sizeof(wchar_t));
		RegSetValueExW(phkResult, L"Path", 0, REG_SZ, (const BYTE *)pathdll, (MTRLEN(pathdll)+1)*sizeof(wchar_t));
#else
		RegSetValueExA(phkResult, "",     0, REG_SZ, (const BYTE *)pathexe, (MTRLEN(pathexe)+1)*sizeof(wchar_t));
		RegSetValueExA(phkResult, "Path", 0, REG_SZ, (const BYTE *)pathdll, (MTRLEN(pathdll)+1)*sizeof(wchar_t));
#endif
    }
	ix = RegCloseKey(phkResult);
	return 0;
}

//==============================================================================
//  WXgHKEY_LOCAL_MACHINȄݒ肷
//==============================================================================
int SetReg(UNICHAR *pathexe, UNICHAR *pathdll, UNICHAR *exename) {
	HKEY phkResult;
	long ix;
	UNICHAR lpszSubKey[REGPATH_SIZE];

	MTRCPY( lpszSubKey, sizeof(lpszSubKey), SUBKEY );
	MTRCAT( lpszSubKey, sizeof(lpszSubKey), exename );
#ifdef _UNICODE_TABLE
	ix = RegOpenKeyExW(HKEY_LOCAL_MACHINE, lpszSubKey, 0, KEY_READ | KEY_WRITE, &phkResult);
#else
	ix = RegOpenKeyExA(HKEY_LOCAL_MACHINE, lpszSubKey, 0, KEY_READ | KEY_WRITE, &phkResult);
#endif
	if ( ix == 0 ) {
#ifdef _UNICODE_TABLE
		RegSetValueExW(phkResult, L"",     0, REG_SZ, (const BYTE *)pathexe, (MTRLEN(pathexe)+1)*sizeof(wchar_t));
		RegSetValueExW(phkResult, L"Path", 0, REG_SZ, (const BYTE *)pathdll, (MTRLEN(pathdll)+1)*sizeof(wchar_t));
#else
		RegSetValueExA(phkResult, "",     0, REG_SZ, (const BYTE *)pathexe, (MTRLEN(pathexe)+1)*sizeof(wchar_t));
		RegSetValueExA(phkResult, "Path", 0, REG_SZ, (const BYTE *)pathdll, (MTRLEN(pathdll)+1)*sizeof(wchar_t));
#endif
    }
	ix = RegCloseKey(phkResult);
	return 0;
}

//==============================================================================
//  WXg폜
//==============================================================================
int DelReg(UNICHAR *exename) {
	long ix;
	UNICHAR lpszSubKey[REGPATH_SIZE];

	MTRCPY( lpszSubKey, sizeof(lpszSubKey), SUBKEY );
	MTRCAT( lpszSubKey, sizeof(lpszSubKey), exename );
#ifdef _UNICODE_TABLE
	ix = RegDeleteKeyW(HKEY_LOCAL_MACHINE, lpszSubKey);
#else
	ix = RegDeleteKeyA(HKEY_LOCAL_MACHINE, lpszSubKey);
#endif
	return 0;
}
