//*****************************************************************************
//* Copyright (c) 2012 Miday Workshop All rights reserved.
//*
//* File: CalcCom.cpp
//*****************************************************************************

#ifdef _WINDOWS_PLAT
#include <windows.h>
#else  //_WINDOWS_PLAT
#include <stdint.h>
#endif  //_WINDOWS_PLAT
#include <new>
#include <string.h>
#include <wchar.h>
#include "CalcDef.h"
#include "MsgLocale.h"

//p[^͂̕ϐ
UNICHAR AppPath[FILENAME_SIZE];    //AvP[VpX
UNICHAR Inifile[FILENAME_SIZE];    //InitFile
int ClipWaitCount, ClipWaitTime, TimeLog, AsciiWide, HoriWide;
#ifdef _UNICODE_TABLE
wchar_t Locale[500];
#endif  //_UNICODE_TABLE
UNICHAR Evasion[50];

#ifdef _WINDOWS_PLAT
SYSTEMTIME Just1, Just2;
#else  //_WINDOWS_PLAT
#include <time.h>
struct tm *Just1, *Just2;
#endif  //_WINDOWS_PLAT

CELL *hyo;
#if defined(_JPN) || defined(_ENG)
POS *yoko_p;
POS *tate_p;
#endif  //_JPN _ENG
CHAR_LEN out_data;
CHAR_LEN out_wk_data;
UNICHAR *clip_data;
int *font_attr;
int *cell_attr;

int Col_no, Row_no;
int irc;
int Verno;

int Break_flag;//=0 LZ@=1 LZ@=2 LZI
int Allline_flag;//=0 mF@=1 SĂ̘gt邱ƂmF
int Area_pos;//̈mۏ͂ǂ܂Ői񂾂
int Out_alloc;//o͗p̗̈mۂ
int Out_wk_alloc;//Ɨp̗̈mۂ
int Clip_alloc;//Nbv{[gf[^荞񂾂
int Proc_pos;//s͂ǂ̎_
int Use_pos;//ϐgp͂ǂ܂Ői񂾂
int Use_flag[10];//ϐ͎gpĂ邩

int font_attr_maxno;//f[^̐
int font_attr_no;//ݎgp̕f[^̔ԍ
int font_attr_alloc;//f[^̗̈mۂ
int cell_attr_maxno;//Zf[^̐
int cell_attr_no;//ݎgp̃Zf[^̔ԍ
int cell_attr_alloc;//Zf[^̗̈mۂ

int text_flag;//Nbv{[h̃f[^̃^Cv@IN_TEXTDATA/IN_UNIDATA/IN_CALCDATA

//==============================================================================
//̎w͈͂1oCg邩`FbN
//==============================================================================
int HalfCheck(UNICHAR *indata, int sa, int ea) {
	int ja, ma;
	ja = 0;
	for(ma=sa; ma<=ea; ma++) {
#ifdef _UNICODE_TABLE
		if ( indata[ma] >= LIT_K61 && indata[ma] <= LIT_K9F ) {
			ja++;
		} else {
#endif  //_UNICODE_TABLE
			if ( indata[ma] < LIT_KFF ) {
				ja++;
			}
#ifdef _UNICODE_TABLE
		}
#endif  //_UNICODE_TABLE
	}
	return ja;
}

//==============================================================================
//̈mۂ
//==============================================================================
int AllocArea() {
	int ia, irc;

	try{
		hyo    = new CELL[(Col_no)*(Row_no)];
		Area_pos = 1;
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			hyo[ia].text.size = -1;
//			hyo[ia].type = CELL_TYPE_TEXT;
			hyo[ia].merge[AR_FLAG] = 0;
			hyo[ia].merge[AR_BASE] = 0;
		}

#if defined(_JPN) || defined(_ENG)
		yoko_p = new POS[Col_no];
#endif  //_JPN _ENG
		Area_pos = 2;
#if defined(_JPN) || defined(_ENG)
		tate_p = new POS[Row_no];
#endif  //_JPN _ENG
		Area_pos = 3;
#if defined(_JPN) || defined(_ENG)
		for ( ia=0; ia<Col_no; ia++ ) {
			yoko_p[ia].posp = 0;
			yoko_p[ia].posw = 0;
		}
		for ( ia=0; ia<Row_no; ia++ ) {
			tate_p[ia].posp = 0;
			tate_p[ia].posw = 0;
		}
#endif  //_JPN _ENG

	}
#if _MSC_VER > 1200
	catch (std::bad_alloc) {
#else  //MSC
//VC6 ȉ
	catch (...) {
#endif  //MSC
		irc = MessageDisp( MSG_ER_MEM2_CODE );
		return MEMORY_ERROR;
	}
#if _MSC_VER > 1200
	catch (...) {
		irc = MessageDisp( MSG_ER_MEM3_CODE );
		return MEMORY_ERROR;
	}
#endif  //MSC
	return NOMAL_RETURN;
}

//==============================================================================
//̈J out_dataclip_dataJ
//==============================================================================
void FreeArea() {
//ȉ͌
//LZG[@̃t@CĂ
//OLE G[@@@@@@@@AutoWrapĂ
//̑̃G[@@@@@@CalcGetĂ
	int ia;
	if ( Area_pos >= 1 ) {
		for (ia=0; ia<Col_no*Row_no; ia++ ) {
			if ( hyo[ia].text.size != -1 ) {
				CharLenFree(&hyo[ia].text);
			}
		}
		delete[] hyo;
	}
#if defined(_JPN) || defined(_ENG)
	if ( Area_pos >= 2 ) delete[] yoko_p;
	if ( Area_pos >= 3 ) delete[] tate_p;
#endif  //_JPN _ENG
	Area_pos         = 0;

#ifdef _WINDOWS_PLAT
//linux́Adestroy_progress@ōs
	if ( Out_alloc == 1 ) CharLenFree(&out_data);
	Out_alloc        = 0;
#endif  //_WINDOWS_PLAT

	if ( Out_wk_alloc == 1 ) CharLenFree(&out_wk_data);
	Out_wk_alloc     = 0;

	if ( Clip_alloc == 1 ) delete[] clip_data;
	Clip_alloc       = 0;

	if ( font_attr_alloc == 1 ) delete[] font_attr;
	font_attr_alloc  = 0;

	if ( cell_attr_alloc == 1 ) delete[] cell_attr;
	cell_attr_alloc  = 0;
}

//==============================================================================
//w肳ꂽ̐擪oCg`FbNAɉoCg邩Ԃ
//VtgJIS EUC-JP ̏
//==============================================================================
int ByteChk(UNICHAR ch) {
#ifdef _WINDOWS_PLAT
	return 0;
#ifdef _UNICODE_TABLE
#else  //_UNICODE_TABLE
	//VtgJIS
	if ((ch >= LIT_H81 && ch <= LIT_H9F) || (ch >= LIT_HE0 && ch <= LIT_HFC)) {
		return 1;
	}
#endif  //_UNICODE_TABLE
#else  //_WINDOWS_PLAT
#ifdef _UNICODE_TABLE
	return 0;
#else  //_UNICODE_TABLE
	//EUC-JP   eXgĂȂ
	if ((ch == LIT_H8E) || (ch >= LIT_HA1 && ch <= LIT_HFE)) {
		return 1;
	} else if (ch == LIT_H8F) {
		return 2;
	}
#endif  //_UNICODE_TABLE
#endif  //_WINDOWS_PLAT
	return 0;
}

//==============================================================================
//Nbv{[h荞񂾃f[^𕪊
//Col_no  Row_no ̊Oϐɂlݒ肷
//mۂƂ Col_no  Row_no gp
//==============================================================================
int DataDivision(UNICHAR *indata) {
//indata@ Nbv{[h̃f[^
	int ia, ib, ic, ip, ir, is;

//------------------------------------------------------------------------------
//\̘g߂
//------------------------------------------------------------------------------
	ib = 1;
	Col_no = 0;
	Row_no = 1;
	for (ia=0; ia<(int)MTRLEN(indata); ia++ ) {
		if (indata[ia] == LIT_TAB_C ) {
			ib++;
		}
		if (indata[ia] == LIT_HLF ) {  //CR-LF LF    macΉ
			if ( ib > Col_no ) {
				Col_no = ib;
			}
			if ( ia != (int)MTRLEN(indata) - 1 ) {
				(Row_no)++;
			}
			ib = 1;
		}
		ia = ia + ByteChk(indata[ia]);
	}
	if ( ib > Col_no ) Col_no = ib;

//------------------------------------------------------------------------------
//\̘gɒlݒ
//------------------------------------------------------------------------------
	//̈m
	if ( AllocArea() != 0 ) {
		return MEMORY_ERROR;
	}

	for ( ir=0; ir<(Row_no); ir++ ) {
		for ( ib=0; ib<(Col_no); ib++ ) {
			for ( ip=0; ip<4; ip++ ) {
				hyo[(Col_no)*ir+ib].line[ip]   = 0;
#if defined(_WIKI) || defined(_HTML)
				hyo[(Col_no)*ir+ib].lcolor[ip] = (unsigned int)0x00000000;//
#endif  //_WIKI _HTML
			}
#if defined(_WIKI) || defined(_HTML)
			hyo[(Col_no)*ir+ib].fcolor        = (unsigned int)0x00000000;//
			hyo[(Col_no)*ir+ib].size          = 10;//ftHg
			hyo[(Col_no)*ir+ib].bold          = false;//ftHg
			hyo[(Col_no)*ir+ib].italic        = false;//ftHg
			hyo[(Col_no)*ir+ib].underline     = FONT_UNDERLINE_NONE;//ftHg
			hyo[(Col_no)*ir+ib].strikethrough = 0;//ftHg
			hyo[(Col_no)*ir+ib].bcolor        = (unsigned int)0x00ffffff;//
#endif  //_WIKI _HTML
		}
	}

	ib = 0;
	ir = 0;
	is = 0;
	if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
		if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
			return MEMORY_ERROR;
		}
	}
	for ( ia=0; ia<(int)MTRLEN(indata); ia++ ) {
		if (indata[ia] == LIT_TAB_C ) {
			if(ia-is > 0) {
				MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], ia-is);
				hyo[(Col_no)*ir+ib].text.data[ia-is] = LIT_NULL_C;
			} else {
				hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
			}
			is = ia + 1;
			ib++;
			if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
				if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
					return MEMORY_ERROR;
				}
				for ( ip=0; ip<4; ip++ ) {
					hyo[(Col_no)*ir+ib].line[ip] = 0;
				}
			}
		}
		if (indata[ia] == LIT_HLF ) {  //CR-LF LF    macΉ
			if (indata[ia-1] == LIT_HCR ) {  //CR-LF CR
				ic = 1;
			} else {
				ic = 0;
			}
			if(ia-is > 0) {
				MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], ia-is-ic);
				hyo[(Col_no)*ir+ib].text.data[ia-is-ic] = LIT_NULL_C;
			} else {
				hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
			}
			is = ia + 1;
			ir++;
			ib = 0;
			if ( (Col_no)*ir+ib < (Col_no)*(Row_no) ) {
				if ( CharLenNewAlloc(&hyo[(Col_no)*ir+ib].text, MTRLEN(indata)) == MEMORY_ERROR ) {
					return MEMORY_ERROR;
				}
				for ( ip=0; ip<4; ip++ ) {
					hyo[(Col_no)*ir+ib].line[ip] = 0;
				}
			}
		}
		ia = ia + ByteChk(indata[ia]);
	}
	if (is != (int)MTRLEN(indata) ) {
		if(MTRLEN(indata)-is+1 > 0) {
			MTRNCPY(hyo[(Col_no)*ir+ib].text.data, hyo[(Col_no)*ir+ib].text.size+1, &indata[is], MTRLEN(indata)-is);
			hyo[(Col_no)*ir+ib].text.data[MTRLEN(indata)-is] = LIT_NULL_C;
		} else {
			hyo[(Col_no)*ir+ib].text.data[0] = LIT_NULL_C;
		}

//MessageBoxW(NULL, hyo[(Col_no)*ir+ib].text.data, indata, 0);
	}
	return NOMAL_RETURN;
}
