//*****************************************************************************
//* Copyright (c) 2012-2013 Miday Workshop All rights reserved.
//*
//* File: WrapMain.cpp
//*****************************************************************************

#include <stdlib.h>
#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <locale.h>

#include "CalcDef.h"
#include "MsgLocale.h"

#ifdef _UNICODE_TABLE
#define LD_PATH  (wchar_t*)L"LD_LIBRARY_PATH"
#ifdef _JPN
#define RUNFILE (wchar_t *)L"CMd"
#elif _ENG
#define RUNFILE (wchar_t *)L"CMed"
#elif _WIKI
#define RUNFILE (wchar_t *)L"CWd"
#elif _HTML
#define RUNFILE (wchar_t *)L"CHd"
#endif  //_JPN
#else  //_UNICODE_TABLE
#define LD_PATH  "LD_LIBRARY_PATH"
#ifdef _JPN
#define RUNFILE "CMd"
#elif _ENG
#define RUNFILE "CMed"
#elif _WIKI
#define RUNFILE "CWd"
#elif _HTML
#define RUNFILE "CHd"
#endif  //_JPN
#endif  //_UNICODE_TABLE

//dummy
int MessageDisp(int) {
	return 0;
}

//==============================================================================
//setlocalë wchar_t* ɂbp[
//==============================================================================
char* wsetlocale(int category, wchar_t* locale) {
	char *c, *p;
	int sizew, sizew2;
	sizew = wcstombs( NULL, locale, 0);
	if ( sizew == -1 ) return NULL;
	try{
		c = new char[sizew+1];
	}
	catch (...) {
		return NULL;
	}
	sizew2 = wcstombs( c, locale, sizew);
	c[sizew] = '\0';

	p = setlocale(category, c);

	delete[] c;

	return p;
}

//==============================================================================
//C֐
//==============================================================================
int main(int argc, char *argv[]){
	UNICHAR runfile[FILENAME_SIZE];
	int ia, ib, irc;

#ifdef _UNICODE_TABLE
	wsetlocale( LC_CTYPE, LIT_NULL_S );//P[ݒ
#else  //_UNICODE_TABLE
	setlocale( LC_CTYPE, LIT_NULL_S );//P[ݒ
#endif  //_UNICODE_TABLE

//------------------------------------------------------------------------------
//pX̎擾
//------------------------------------------------------------------------------
#ifdef _UNICODE_TABLE
	if ( strlen(argv[0]) >= sizeof(AppPath) ) {
//		irc = MessageDisp( MSG_ER_PATH_CODE );//oX
		printf("%s\n", MSG_ER_PATH);
		return 0;
	} 
	int sizew2 = mbstowcs( AppPath, argv[0], strlen(argv[0]));
	if ( sizew2 == -1 ) {
//		irc = MessageDisp( MSG_ER_PATH_CODE );//oXs
		printf("%s\n", MSG_ER_PATH);
		return 0;
	}
	AppPath[strlen(argv[0])] = LIT_NULL_C;
#else  //_UNICODE_TABLE
	MTRCPY( AppPath, sizeof(AppPath), argv[0] );
#endif  //_UNICODE_TABLE
	for(ia=MTRLEN(AppPath); ia>0; ia--) {
		if ( AppPath[ia] == SEP_C ) {
			AppPath[ia] = LIT_NULL_C;
			break;
		}
	}

	MTRCPY(runfile, sizeof(runfile), LIT_SINGLE_S);
	MTRCAT(runfile, sizeof(runfile), AppPath);
	MTRCAT(runfile, sizeof(runfile), SEP_S);
	MTRCAT(runfile, sizeof(runfile), RUNFILE);
	MTRCAT(runfile, sizeof(runfile), LIT_SINGLE_S);

	MTRCPY(Inifile, sizeof(Inifile), AppPath);
	MTRCAT(Inifile, sizeof(Inifile), SEP_S);
	MTRCAT(Inifile, sizeof(Inifile), INIFILE);

	irc = ProfileGet(Inifile);
	if ( irc < 0 ) {//R[h\Ȃǂ߂Ȃ
		printf("%s\n", MSG_ER_INIR);
		return 0;
	}

	if ( MTRCMP( Locale, LIT_NULL_S ) != 0 ) {
#ifdef _UNICODE_TABLE
		wsetlocale( LC_CTYPE, Locale );//P[ݒ
#else  //_UNICODE_TABLE
		setlocale( LC_CTYPE, Locale );//P[ݒ
#endif  //_UNICODE_TABLE
	}

//------------------------------------------------------------------------------
//LibreOfficẽpXƃo[W`FbN
//------------------------------------------------------------------------------
	Verno = Soffice_Path_get();

#ifdef _UNICODE_TABLE
	wchar_t *ld1, *ld2;
	ia = wgetenv(LD_PATH, 0, ld2);
	ld1 = new wchar_t[ia+501];

	MTRCPY(ld1, MTRLEN(ld1), OfficeInstPath);
	MTRCAT(ld1, MTRLEN(ld1), (wchar_t*)L"/program:");
	MTRCAT(ld1, MTRLEN(ld1), OfficeInstPath);
	MTRCAT(ld1, MTRLEN(ld1), (wchar_t*)L"/ure/lib");

	if ( ia != 0 ) {
		ld2 = new wchar_t[ia+1];
		ib = wgetenv(LD_PATH, ia, ld2);
		MTRCAT(ld1, MTRLEN(ld1), (wchar_t*)L":");
		MTRCAT(ld1, MTRLEN(ld1), ld2);
		delete ld2;
	}
	wsetenv(LD_PATH, ld1, 1);
	delete ld1;
	wsystem(runfile);
#else  //_UNICODE_TABLE
	char *ld1;
	if ( getenv(LD_PATH) != NULL ) {
		ia = strlen(getenv(LD_PATH));
	} else {
		ia = 0;
	}
	ld1 = new char[ia+501];

	MTRCPY(ld1, MTRLEN(ld1), OfficeInstPath);
	MTRCAT(ld1, MTRLEN(ld1), "/program:");
	MTRCAT(ld1, MTRLEN(ld1), OfficeInstPath);
	MTRCAT(ld1, MTRLEN(ld1), "/ure/lib");
	if ( getenv(LD_PATH) != NULL ) {
		if ( strcmp(getenv(LD_PATH), "") != 0 ) {
			MTRCAT(ld1, MTRLEN(ld1), ":");
			MTRCAT(ld1, MTRLEN(ld1), getenv(LD_PATH));
		}
	} else {
		ld1[0] = '\0';
	}
	setenv(LD_PATH, ld1, 1);
	delete ld1;
	system(runfile);
#endif  //_UNICODE_TABLE

	return 0;
}


